
#define MY_PI 3.141592653589793

typedef struct {
	int radius;		// Radius des Stiftes/Frskopfes
	int speed;		// Maximaler Vorschub
	int type;		// Typ des Stiftes/Frskopfes
	SDL_Surface *image;	// Bild des Stiftes/Frskopfes (ca 20x100)
} CNC_Head;

typedef struct {
	int speed;		// Drehzahl des Frskopfes
	int delay;		// Wartezeit nach anschalten des Stiftes/Frskopfes
	int type;		// Typ des Werkzeugs (0=Stift, 1=Frs-Motor)
	CNC_Head head;
} CNC_Tool;

typedef struct {
	int offset;
	int axis;
	int speed;
	int type;
	float scale;
} CNC_XAxis;
CNC_XAxis XAxis[2];

typedef struct {
	int offset;
	int axis;
	int speed;
	int type;
	float scale;
} CNC_YAxis;
CNC_YAxis YAxis[2];

typedef struct {
	int offset_x;		// X-Diff in mm/10
	int offset_y;		// Y-Diff in mm/10
	int offset_z;		// Z-Diff in mm/10
	int axis;		// Achsen-Nummer
	int speed;		// Achsen-Speed
	int type;		// Typ des Achen-Antriebs (0=Stepper, 1=Servo)
	float scale;		// Achsen-Scale (Stepps/0.1mm)
	CNC_Tool tool;
} CNC_ZAxis;
CNC_ZAxis ZAxis[3];

typedef struct {
	char name[64];
	int speed;
	int m_speed;
	int z_steps;
} CNC_Material;
CNC_Material Material[10];

int cnc_material_num = 0;
int cnc_tool_active = 1;
int cnc_last_tool_offset = -100000;
int cnc_last_updown = 0;

int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;
int cnc_active = 0;
int cnc_z_steps = 10;
int cnc_do_cut = 1;
int cnc_do_fill = 1;
int cnc_zover = 30;
int w_t = 20;

#define IMG_DATA_UNSET 0
#define IMG_DATA_MARK1 1
#define IMG_DATA_MARK2 2
#define IMG_DATA_MARK3 3

// Z-Possition der Material-Oberkante
int z_start = 4500;
// Z-Possition der Material-Unterkante (Auflageflche/Frstiefe)
int z_stop = 4900;

int demo = 0;
