
int cnc_2d_outline(SDL_Surface *Surface, int x_diff, int y_diff, int z_pos) {
	unsigned char *img_data;
	int test_x = 0;
	int test_y = 0;
	int test2_x = 0;
	int test2_y = 0;
	int y_addr = 0;
	int min_x = Surface->w;
	int min_y = Surface->h;
	int max_x = 0;
	int max_y = 0;
	// Extract Layer -> cnc_surface
	Uint32 RGBA_0_0_0 = SDL_MapRGB(Surface->format, 0, 0, 0);
	img_data = malloc((Surface->w * Surface->h) * sizeof(unsigned char));
	if (img_data == NULL) {
		fprintf(stderr, "Cant allocate Memory to Outline the Layout !!!!\n");
		gui_percent = 0;
		sprintf(gui_info, "Outliner: Cant allocate Memory !!!!");
		return 1;
	}
	for (test2_y = 0; test2_y < Surface->h; test2_y++) {
		y_addr = (test2_y * Surface->w);
		for (test2_x = 0; test2_x <= Surface->w; test2_x++) {
			if (sdl_getpixel_fast(Surface, test2_x, Surface->h - test2_y) == RGBA_0_0_0) {
				if (test2_x < min_x) {min_x = test2_x;}
				if (test2_y < min_y) {min_y = test2_y;}
				if (test2_x > max_x) {max_x = test2_x;}
				if (test2_y > max_y) {max_y = test2_y;}
				img_data[y_addr + test2_x] = IMG_DATA_MARK1;
			} else {
				img_data[y_addr + test2_x] = IMG_DATA_UNSET;
			}
		}
	}
	gui_check();
	cnc_active = gui_running;
	gui_running = 1;
	if (cnc_active == 1) {
		cnc_2d_outliner(img_data, Surface->w, z_pos, min_x - ZAxis[cnc_tool_active].tool.head.radius - 2, min_y - ZAxis[cnc_tool_active].tool.head.radius - 2, max_x + ZAxis[cnc_tool_active].tool.head.radius + 2, max_y + ZAxis[cnc_tool_active].tool.head.radius + 2);
	}
	free(img_data);
	gui_percent = 0;
	sprintf(gui_info, "Outliner...done");
	return 0;
}

int cnc_2d_outline_objects(SDL_Surface *Surface, int x_diff, int y_diff, int z_pos, int yinvert, int cinvert, char *title_str) {
	unsigned char *img_data;
	int test_x = 0;
	int test_y = 0;
	int test2_x = 0;
	int test2_y = 0;
	int test3_y = 0;
	int y_addr = 0;
	int min_x = Surface->w;
	int min_y = Surface->h;
	int max_x = 0;
	int max_y = 0;
	// Extract Layer -> cnc_surface
	Uint32 RGBA_0_0_0 = SDL_MapRGB(Surface->format, 0, 0, 0);
	Uint32 RGBA_0_255_0 = SDL_MapRGB(Surface->format, 0, 255, 0);
	img_data = malloc((Surface->w * Surface->h) * sizeof(unsigned char));
	if (img_data == NULL) {
		fprintf(stderr, "Cant allocate Memory to Outline the Layout !!!!\n");
		gui_percent = 0;
		sprintf(gui_info, "Object-Outliner: Cant allocate Memory !!!!");
		return 1;
	}
	sprintf(gui_info, "%s: 0%%", title_str);
	gui_update_button(WidgetID[GUI_INFO], gui_info);
	gui_percent = 0;
	gui_update_progress(WidgetID[GUI_PROGRESS], gui_percent);
	SDL_GL_SwapBuffers();
	for (test_x = 0; cnc_active == 1 && test_x <= Surface->w; test_x++) {
		for (test_y = 0; cnc_active == 1 && test_y < Surface->h; test_y++) {
			if (sdl_getpixel_fast(Surface, test_x, test_y) == RGBA_0_0_0) {
				// Objekt makieren
				sge_FloodFill(Surface, test_x, test_y, RGBA_0_255_0);
				// Feines Kontur-Frsen
				min_x = Surface->w;
				min_y = Surface->h;
				max_x = 0;
				max_y = 0;
				for (test2_y = 0; test2_y < Surface->h; test2_y++) {
					y_addr = (test2_y * Surface->w);
					for (test2_x = 0; test2_x <= Surface->w; test2_x++) {
						if (yinvert == 1) {
							test3_y = Surface->h - test2_y;
						} else {
							test3_y = test2_y;
						}
						if (sdl_getpixel_fast(Surface, test2_x, test3_y) == RGBA_0_255_0) {
							if (test2_x < min_x) {min_x = test2_x;}
							if (test2_y < min_y) {min_y = test2_y;}
							if (test2_x > max_x) {max_x = test2_x;}
							if (test2_y > max_y) {max_y = test2_y;}
							if (cinvert == 1) {
								img_data[y_addr + test2_x] = IMG_DATA_UNSET;
							} else {
								img_data[y_addr + test2_x] = IMG_DATA_MARK1;
							}
						} else {
							if (cinvert == 1) {
								img_data[y_addr + test2_x] = IMG_DATA_MARK1;
							} else {
								img_data[y_addr + test2_x] = IMG_DATA_UNSET;
							}
						}
					}
				}
				gui_check();
				cnc_active = gui_running;
				gui_running = 1;
				if (cnc_active == 1) {
					cnc_2d_outliner(img_data, Surface->w, z_pos, min_x - ZAxis[cnc_tool_active].tool.head.radius - 2, min_y - ZAxis[cnc_tool_active].tool.head.radius - 2, max_x + ZAxis[cnc_tool_active].tool.head.radius + 2, max_y + ZAxis[cnc_tool_active].tool.head.radius + 2);
				}
				// Objekt als fertig kenzeichnen
				sge_FloodFill(Surface, test_x, test_y, SDL_MapRGB(Surface->format, 0, 0, 255));
				sprintf(gui_info, "%s: %0.0f%%", title_str, (float)test_x / (float)Surface->w * 100.0);
				gui_update_button(WidgetID[GUI_INFO], gui_info);
				gui_percent = (int)((float)test_x / (float)Surface->w * 100.0);
				gui_update_progress(WidgetID[GUI_PROGRESS], gui_percent);
				SDL_GL_SwapBuffers();
			}
		}
		gui_check();
		cnc_active = gui_running;
		gui_running = 1;
	}
	free(img_data);
	gui_percent = 0;
	sprintf(gui_info, "%s: done", title_str);
	return 0;
}

int cnc_2d_outliner(unsigned char *img_data, int width, int z_pos, int min_x, int min_y, int max_x, int max_y) {
	int test_x = 0;
	int test_y = 0;
	int y_addr = 0;
	int flag = 0;
	int min2_x = max_x;
	int min2_y = max_y;
	int max2_x = min_x;
	int max2_y = min_y;
	flag = 0;
	if (min_x < 0) {min_x = 0;}
	if (min_y < 0) {min_y = 0;}
	gui_check();
	cnc_active = gui_running;
	gui_running = 1;
	for (test_y = min_y; cnc_active == 1 && test_y <= max_y; test_y++) {
		y_addr = (test_y * width);
		for (test_x = min_x; test_x <= max_x; test_x++) {
			if (img_data[y_addr + test_x] == IMG_DATA_UNSET) {
				if (cnc_check_circle(img_data, width, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius + 1, ZAxis[cnc_tool_active].tool.head.radius + 1) != 0 && cnc_check_circle(img_data, width, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius, 1) == 0) {
					if (test_x < min2_x) {min2_x = test_x;}
					if (test_y < min2_y) {min2_y = test_y;}
					if (test_x > max2_x) {max2_x = test_x;}
					if (test_y > max2_y) {max2_y = test_y;}
					img_data[y_addr + test_x] = IMG_DATA_MARK2;
					flag = 1;
				}
			}
		}
		gui_check();
		cnc_active = gui_running;
		gui_running = 1;
	}
	if (cnc_active == 1 && flag == 1) {
		cnc_2d_liner(img_data, width, z_pos, min2_x - ZAxis[cnc_tool_active].tool.head.radius - 2, min2_y - ZAxis[cnc_tool_active].tool.head.radius - 2, max2_x + ZAxis[cnc_tool_active].tool.head.radius + 2, max2_y + ZAxis[cnc_tool_active].tool.head.radius + 2, 1);
	}
	return 0;
}

