
#include "ecad.h"
#include "ecad_line.c"
#include "ecad_lines.c"
#include "ecad_pad.c"
#include "ecad_ic.c"
#include "ecad_to220.c"
#include "ecad_rectangle.c"
#include "ecad_box.c"
#include "ecad_text.c"
#include "ecad_mount.c"
#include "ecad_resistor.c"
#include "ecad_xtal.c"
#include "ecad_gnd.c"
#include "ecad_pinconn.c"

int ecad_file_add_lib(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int ecad_id = ecad_get_free_id();
	if ((stream = fopen(filename, "r")) != 0) {
		while(fread(&ECAD[ecad_id], sizeof(Ecad_Element), 1, stream) != 0) {
			ECAD[ecad_id].x1 += (5.0 * ecad_raster);
			ECAD[ecad_id].y1 += (5.0 * ecad_raster);
			ECAD[ecad_id].x2 += (5.0 * ecad_raster);
			ECAD[ecad_id].y2 += (5.0 * ecad_raster);
			ECAD[ecad_id].group = ecad_group_id;
			ecad_id = ecad_get_free_id();
                }
		fclose(stream);
	}
	ecad_group_id++;
	ecad_active_id = ecad_get_free_id();
	return 0;
}

int ecad_hpgl_last_x = 0;
int ecad_hpgl_last_y = 0;
int ecad_hpgl_pen_z = 0;

int ecad_hpgl2ecad(char *hpgl_cmd) {
	int ecad_id = ecad_get_free_id();
	char *loc;
	int x = 0;
	int y = 0;
	ecad_id = ecad_get_free_id();
	if (hpgl_cmd[0] == 'I') {
		if (hpgl_cmd[1] == 'N') {
		} else if (hpgl_cmd[1] == 'W') {
		}
	} else if (hpgl_cmd[0] == 'P') {
		if (hpgl_cmd[1] == 'A') {
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = atoi(hpgl_cmd + 2) / 4 * 10;
				y = atoi(loc + 1) / 4 * 10;
				if (ecad_hpgl_pen_z == 1) {
					ecad_active_id = ecad_get_free_id();
					ecad_set_color(ecad_active_id);
					ecad_set_line(1, 0, ecad_hpgl_last_x, ecad_hpgl_last_y, x, y, ecad_linesize);
				}
				ecad_hpgl_last_x = x;
				ecad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'R') {
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = ecad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = ecad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				if (ecad_hpgl_pen_z == 1) {
					ecad_active_id = ecad_get_free_id();
					ecad_set_color(ecad_active_id);
					ecad_set_line(1, 0, ecad_hpgl_last_x, ecad_hpgl_last_y, x, y, ecad_linesize);
				}
				ecad_hpgl_last_x = x;
				ecad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'U') {
			ecad_hpgl_pen_z = 0;
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = ecad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = ecad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				ecad_hpgl_last_x = x;
				ecad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'D') {
			ecad_hpgl_pen_z = 1;
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = ecad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = ecad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				ecad_active_id = ecad_get_free_id();
				ecad_set_color(ecad_active_id);
				ecad_set_line(1, 0, ecad_hpgl_last_x, ecad_hpgl_last_y, x, y, ecad_linesize);
				ecad_hpgl_last_x = x;
				ecad_hpgl_last_y = y;
			}
		}
	} else if (hpgl_cmd[0] == 'S') {
		if (hpgl_cmd[1] == 'P') {
		}
	}
	ECAD[ecad_id].group = ecad_group_id;
	return 0;
}

int ecad_file_add_hpgl(char *filename) {
	FILE *stream;
	char tmp_str[512];
	char tmp_char;
	int n = 0;
	tmp_str[0] = 0;
	n = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		while(fread(&tmp_char, 1, 1, stream) != 0) {
			if (tmp_char == '\n' || tmp_char == ';') {
				tmp_str[n] = 0;
				ecad_hpgl2ecad(tmp_str);
				tmp_str[0] = 0;
				n = 0;
			} else {
				tmp_str[n++] = tmp_char;
			}
		}
		ecad_hpgl2ecad(tmp_str);
		fclose(stream);
	}
	ecad_group_id++;
	return 0;
}


int ecad_file_add_dxf(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int n = 0;
	int mode = 0;
	int x[10];
	int y[10];
	int z[10];
	int l = 0;
	int c = 0;
	int rc = 0;
	tmp_str[0] = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		while(!feof(stream)) {
			fgets(tmp_str, 512, stream);
			n = 0;
			while (tmp_str[n] == ' ') {
				n++;
			}
			if (tmp_str[n] - 48 == 0) {
				if (mode == 1) {
// 					fprintf(stderr, "Line(%i): %i,%i,%i -> %i,%i,%i\n", rc++, x[0], y[0], z[0], x[1], y[1], z[1]);
					ecad_active_id = ecad_get_free_id();
					ecad_set_color(ecad_active_id);
					ecad_set_line(1, 0, x[0], y[0], x[1], y[1], ecad_linesize);
				}
				fgets(tmp_str, 512, stream);
				if (strcmp(tmp_str, "SECTION\n") == 0) {
					mode = 0;
				} else if (strcmp(tmp_str, "LINE\n") == 0 || strcmp(tmp_str, "3DLINE\n") == 0) {
					mode = 1;
				} else if (strcmp(tmp_str, "CIRCLE\n") == 0) {
					mode = 2;
				} else if (strcmp(tmp_str, "3DFACE\n") == 0) {
					mode = 3;
				} else if (strcmp(tmp_str, "ENDSEC\n") == 0) {
					mode = 0;
				} else if (strcmp(tmp_str, "EOF\n") == 0) {
					mode = 0;
				}
			} else if (tmp_str[n] - 48 == 8) {
				fgets(tmp_str, 512, stream);
				l = atoi(tmp_str);
			} else if (mode == 1 && tmp_str[n] - 48 == 1) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				x[c] = (int)(atof(tmp_str) * 100.0);
			} else if (mode == 1 && tmp_str[n] - 48 == 2) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				y[c] = (int)(atof(tmp_str) * 100.0);
			} else if (mode == 1 && tmp_str[n] - 48 == 3) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				z[c] = (int)(atof(tmp_str) * 100.0);
			}
		}
		fclose(stream);
	}
	ecad_group_id++;
	return 0;
}

int ecad_add_pad(int x, int y, int size, int dtype) {
	int x1;
	int y1;
	int x2;
	int y2;
	if (ecad_show_bottom_cu == 1) {
		if (dtype == 0) {
			boxRGBA(ECAD_Surface, ecad_zoom_int(x - (size / 2)), ecad_zoom_int(y - (size / 2)), ecad_zoom_int(x + (size / 2)), ecad_zoom_int(y + (size / 2)), bc_r, bc_g, bc_b, bc_a);
		} else {
			filledCircleRGBA(ECAD_Surface, ecad_zoom_int(x), ecad_zoom_int(y), ecad_zoom_int((size / 2)), bc_r, bc_g, bc_b, bc_a);
		}
		x1 = ecad_zoom_int(x - (size / 2));
		y1 = ecad_zoom_int(y - (size / 2));
		x2 = ecad_zoom_int(x + (size / 2));
		y2 = ecad_zoom_int(y + (size / 2));
		glBegin(GL_QUADS);
		glColor3f(0.5, 0.5, 0.5);
		glVertex3f(x1, y1, 0.2);
		glVertex3f(x2, y1, 0.2);
		glVertex3f(x2, y2, 0.2);
		glVertex3f(x1, y2, 0.2);
		glColor3f(0.3, 0.3, 0.2);
		glVertex3f(x1, y1, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x2, y1, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x2, y2, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x1, y2, -200.0 * ecad_zoom - 0.2);
		glEnd();
	}
	if (ecad_show_top_label == 1) {
		if (dtype == 0) {
			rectangleRGBA(ECAD_Surface, ecad_zoom_int(x - (size / 2) - 2), ecad_zoom_int(y - (size / 2) - 2), ecad_zoom_int(x + (size / 2) + 2), ecad_zoom_int(y + (size / 2) + 2), tl_r, tl_g, tl_b, tl_a);
		} else {
			circleRGBA(ECAD_Surface, ecad_zoom_int(x), ecad_zoom_int(y), ecad_zoom_int((size / 2)), tl_r, tl_g, tl_b, tl_a);
		}
	}
	if (ecad_show_bottom_cu == 1 && ecad_show_drill == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(x), ecad_zoom_int(y), ecad_zoom_int(30), 0, 0, 0, 255);
	} else if (ecad_show_drill == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(x), ecad_zoom_int(y), ecad_zoom_int(30), d_r, d_g, d_b, d_a);
	}
	if (ecad_show_drill == 1) {
		x1 = ecad_zoom_int(x - (size / 6));
		y1 = ecad_zoom_int(y - (size / 6));
		x2 = ecad_zoom_int(x + (size / 6));
		y2 = ecad_zoom_int(y + (size / 6));
		glBegin(GL_QUADS);
		glColor3f(0.0, 0.0, 0.0);
		glVertex3f(x1, y1, 0.4);
		glVertex3f(x2, y1, 0.4);
		glVertex3f(x2, y2, 0.4);
		glVertex3f(x1, y2, 0.4);
		glVertex3f(x1, y1, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x2, y1, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x2, y2, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x1, y2, -200.0 * ecad_zoom - 0.4);
		glEnd();
	}
	return 0;
}

int ecad_zoom_int(int value) {
	return (int)((float)value * ecad_zoom);
}

int ecad_unzoom_int(int value) {
	return (int)((float)value / ecad_zoom);
}

int ecad_clean_select(void) {
	ECAD[ecad_active_id].type = 0;
	ECAD[ecad_active_id].x1 = 0;
	ECAD[ecad_active_id].y1 = 0;
	ECAD[ecad_active_id].x2 = 0;
	ECAD[ecad_active_id].y2 = 0;
	ECAD[ecad_active_id].size = 0;
	ECAD[ecad_active_id].dtype = 0;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = 0;
	ECAD[ecad_active_id].view = 0;
	ECAD[ecad_active_id].layer = 0;
	ECAD[ecad_active_id].selected = 0;
	ECAD[ecad_active_id].text[0] = 0;
	ECAD[ecad_active_id].info[0] = 0;
	ecad_select = 0;
	return 0;
}

int ecad_file_load(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int ecad_id = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		ecad_init();
		strcpy(ecad_filename, filename);
		while(fread(&ECAD[ecad_id], sizeof(Ecad_Element), 1, stream) != 0) {
			ecad_id++;
                }
		ecad_active_id = ecad_get_free_id();
		fclose(stream);
	}
	return 0;
}

int ecad_file_save(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int ecad_id = 0;
	if ((stream = fopen(filename, "w")) != 0) {
		ecad_select_delete();
		ecad_clean_select();
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0) {
				fwrite(&ECAD[ecad_id], sizeof(Ecad_Element), 1, stream);
			}
		}
		fclose(stream);
	}
	return 0;
}

int ecad_get_free_id(void) {
	int ecad_id = 0;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].type == 0) {
			return ecad_id;
		}
	}
	return -1;
}

int ecad_toggle_show_top_label(void) {
	ecad_show_top_label = 1 - ecad_show_top_label;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].action = ecad_show_top_label + 1;
	return 0;
}

int ecad_toggle_show_bottom_cu(void) {
	ecad_show_bottom_cu = 1 - ecad_show_bottom_cu;
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].action = ecad_show_bottom_cu + 1;
	return 0;
}

int ecad_toggle_show_drill(void) {
	ecad_show_drill = 1 - ecad_show_drill;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].action = ecad_show_drill + 1;
	return 0;
}

int ecad_set_color(int ecad_id) {
	bc_r = 8;
	bc_g = 120;
	bc_b = 5;
	bc_a = 255;
	tl_r = 255;
	tl_g = 255;
	tl_b = 255;
	tl_a = 255;
	d_r = 255;
	d_g = 20;
	d_b = 20;
	d_a = 255;
	if (ecad_export != 0) {
		bc_r = 0;
		bc_g = 0;
		bc_b = 0;
		bc_a = 255;
		tl_r = 0;
		tl_g = 0;
		tl_b = 0;
		tl_a = 255;
		d_r = 0;
		d_g = 0;
		d_b = 0;
		d_a = 255;
	} else if (ecad_mouse_mode == M_SELECT && ECAD[ecad_id].selected == 1) {
		bc_r = 255;
		bc_g = 0;
		bc_b = 0;
		bc_a = 255;
		tl_r = 255;
		tl_g = 0;
		tl_b = 0;
		tl_a = 255;
		d_r = 255;
		d_g = 0;
		d_b = 0;
		d_a = 255;
	} else if (ECAD[ecad_id].mode == 0) {
		bc_r = 128;
		bc_g = 128;
		bc_b = 128;
		bc_a = 128;
		tl_r = 128;
		tl_g = 128;
		tl_b = 128;
		tl_a = 128;
		d_r = 128;
		d_g = 128;
		d_b = 128;
		d_a = 128;
	}
	return 0;
}

int ecad_size_x(void) {
	int ecad_id = 0;
	int x = 0;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].view != 0 && ECAD[ecad_id].type == DRAW_RECTANGLE) {
			if (x < ecad_zoom_int(ECAD[ecad_id].x2)) {
				x = ECAD[ecad_id].x2;
			}
		}
	}
	return x;
}

int ecad_size_y(void) {
	int ecad_id = 0;
	int y = 0;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].view != 0 && ECAD[ecad_id].type == DRAW_RECTANGLE) {
			if (y < ecad_zoom_int(ECAD[ecad_id].y2)) {
				y = ECAD[ecad_id].y2;
			}
		}
	}
	return y;
}

int ecad_minsize_x(void) {
	int ecad_id = 0;
	int x = ecad_size_x();
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].view != 0) {
			if (x > ECAD[ecad_id].x1) {
				x = ECAD[ecad_id].x1;
			}
		}
	}
	return x;
}

int ecad_minsize_y(void) {
	int ecad_id = 0;
	int y = ecad_size_y();
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].view != 0) {
			if (y > ECAD[ecad_id].y1) {
				y = ECAD[ecad_id].y1;
			}
		}
	}
	return y;
}

int ecad_draw(void) {
	int ecad_id = 0;
	int n = 0;
	if (ecad_export == 0) {
		boxRGBA(ECAD_Surface, 0, 0, ECAD_Surface->w - 1, ECAD_Surface->h - 1, 0, 0, 0, 255);
	} else {
		boxRGBA(ECAD_Surface, 0, 0, ECAD_Surface->w - 1, ECAD_Surface->h - 1, 255, 255, 255, 255);
	}
	if (ecad_show_top_label == 1 && ecad_show_bottom_cu == 1) {
		ecad_show_top_label = 0;
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			ecad_set_color(ecad_id);
			if (ECAD[ecad_id].view != 0 && (ECAD[ecad_id].type == DRAW_LINE || ECAD[ecad_id].type == DRAW_LINES || ECAD[ecad_id].type == DRAW_BOX)) {
				(*ecad_drawit[ECAD[ecad_id].type])(ecad_id);
			}
		}
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0 && (ECAD[ecad_id].type != DRAW_LINE && ECAD[ecad_id].type != DRAW_LINES && ECAD[ecad_id].type != DRAW_BOX)) {
				ecad_set_color(ecad_id);
				(*ecad_drawit[ECAD[ecad_id].type])(ecad_id);
			}
		}
		// mark GND-Lines
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].type == DRAW_GND) {
				sge_FloodFill(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), SDL_MapRGB(ECAD_Surface->format, 0, 0, 255));
			}
		}
		// select-Lines
// 		if (sdl_getpixel(ECAD_Surface, ecad_zoom_int(event.button.x), ecad_zoom_int(event.button.y)) != SDL_MapRGB(ECAD_Surface->format, 0, 0, 0)) {
// 			sge_FloodFill(ECAD_Surface, ecad_zoom_int(event.button.x), ecad_zoom_int(event.button.y), SDL_MapRGB(ECAD_Surface->format, 255, 0, 0));
// 		}
		ecad_show_top_label = 1;
		ecad_show_bottom_cu = 0;
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0 && (ECAD[ecad_id].type != DRAW_LINE && ECAD[ecad_id].type != DRAW_LINES && ECAD[ecad_id].type != DRAW_BOX)) {
				ecad_set_color(ecad_id);
				d_r = 0;
				d_g = 0;
				d_b = 0;
				d_a = 255;
				(*ecad_drawit[ECAD[ecad_id].type])(ecad_id);
			}
		}
		ecad_show_bottom_cu = 1;
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0) {
				if (ecad_mouse_mode == M_SELECT) {
					circleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), 6, 255, 0, 0, 200);
				}
			}
		}
	} else {
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			ecad_set_color(ecad_id);
			if (ECAD[ecad_id].view != 0 && (ECAD[ecad_id].type == DRAW_LINE || ECAD[ecad_id].type == DRAW_LINES || ECAD[ecad_id].type == DRAW_BOX)) {
				(*ecad_drawit[ECAD[ecad_id].type])(ecad_id);
			}
		}
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0 && (ECAD[ecad_id].type != DRAW_LINE && ECAD[ecad_id].type != DRAW_LINES && ECAD[ecad_id].type != DRAW_BOX)) {
				ecad_set_color(ecad_id);
				(*ecad_drawit[ECAD[ecad_id].type])(ecad_id);
			}
		}
		if (ecad_show_bottom_cu == 1) {
			// mark GND-Lines
			for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
				if (ECAD[ecad_id].type == DRAW_GND) {
					sge_FloodFill(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), SDL_MapRGB(ECAD_Surface->format, 0, 0, 255));
				}
			}
			// select-Lines
// 			if (sdl_getpixel(ECAD_Surface, ecad_zoom_int(event.button.x), ecad_zoom_int(event.button.y)) != SDL_MapRGB(ECAD_Surface->format, 0, 0, 0)) {
// 				sge_FloodFill(ECAD_Surface, ecad_zoom_int(event.button.x), ecad_zoom_int(event.button.y), SDL_MapRGB(ECAD_Surface->format, 255, 0, 0));
// 			}
		}
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].view != 0) {
				if (ecad_mouse_mode == M_SELECT) {
					circleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), 6, 255, 0, 0, 200);
				}
			}
		}
	}

	if (ecad_raster_view == 1) {
		for (n = 0; ecad_zoom_int((int)((float)n * ecad_raster)) < ECAD_Surface->w; n++) {
			lineRGBA(ECAD_Surface, ecad_zoom_int((int)((float)n * ecad_raster)), 0, ecad_zoom_int((int)((float)n * ecad_raster)), ECAD_Surface->h, 40, 140, 40, 60);
		}
		for (n = 0; ecad_zoom_int((int)((float)n * ecad_raster)) < ECAD_Surface->h; n++) {
			lineRGBA(ECAD_Surface, 0, ecad_zoom_int((int)((float)n * ecad_raster)), ECAD_Surface->w, ecad_zoom_int((int)((float)n * ecad_raster)), 40, 140, 40, 60);
		}
		for (n = 0; ecad_zoom_int((int)((float)n * (ecad_raster * 2))) < ECAD_Surface->w; n++) {
			lineRGBA(ECAD_Surface, ecad_zoom_int((int)((float)n * (ecad_raster * 2))), 0, ecad_zoom_int((int)((float)n * (ecad_raster * 2))), ECAD_Surface->h, 20, 120, 20, 80);
		}
		for (n = 0; ecad_zoom_int((int)((float)n * (ecad_raster * 2))) < ECAD_Surface->h; n++) {
			lineRGBA(ECAD_Surface, 0, ecad_zoom_int((int)((float)n * (ecad_raster * 2))), ECAD_Surface->w, ecad_zoom_int((int)((float)n * (ecad_raster) * 2)), 20, 120, 20, 80);
		}
	}
	if (ecad_select_x1 != 0) {
		boxRGBA(ECAD_Surface, ecad_select_x1, ecad_select_y1, ecad_select_x2, ecad_select_y2, 255, 0, 0, 128);
	}
	return 0;
}

int ecad_image_raster_snap(void) {
	ecad_raster_snap = 1 - ecad_raster_snap;
	Widget[WidgetID[GRID_SNAP]].action = ecad_raster_snap + 1;
	return 0;
}

int ecad_image_raster_view(void) {
	ecad_raster_view = 1 - ecad_raster_view;
	Widget[WidgetID[GRID_VIEW]].action = ecad_raster_view + 1;
	return 0;
}

int ecad_move_group(int id, int diff_x1, int diff_y1) {
	int ecad_id;
	int group_id = ECAD[id].group;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].group == group_id) {
			ECAD[ecad_id].x1 -= diff_x1;
			ECAD[ecad_id].y1 -= diff_y1;
			ECAD[ecad_id].x2 -= diff_x1;
			ECAD[ecad_id].y2 -= diff_y1;
		}
	}
	return 0;
}

int ecad_move(void) {
	int ecad_id;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		if (ECAD[ecad_id].view != 0 && ECAD[ecad_id].selected == 1) {
			if (ECAD[ecad_id].x1 == ecad_select_x1 && ECAD[ecad_id].y1 == ecad_select_y1) {
				if (ECAD[ecad_id].group == 0) {
					ECAD[ecad_id].x1 = event.button.x;
					ECAD[ecad_id].y1 = event.button.y;
				} else {
					ecad_move_group(ecad_id, ECAD[ecad_id].x1 - event.button.x, ECAD[ecad_id].y1 - event.button.y);
				}
// 				break;
			} else if (ECAD[ecad_id].x2 == ecad_select_x1 && ECAD[ecad_id].y2 == ecad_select_y1) {
				if (ECAD[ecad_id].group == 0) {
					ECAD[ecad_id].x2 = event.button.x;
					ECAD[ecad_id].y2 = event.button.y;
				} else {
					ecad_move_group(ecad_id, ECAD[ecad_id].x2 - event.button.x, ECAD[ecad_id].y2 - event.button.y);
				}
// 				break;
			}
		}
	}
	ecad_select_x1 = event.button.x;
	ecad_select_y1 = event.button.y;
	ecad_select_x2 = event.button.x;
	ecad_select_y2 = event.button.y;
	return 0;
}

int ecad_image_mover(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.x = ecad_unzoom_int(event.button.x);
	event.button.y = ecad_unzoom_int(event.button.y);
	if (ecad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
		event.button.y = ((int)((float)(event.button.y + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
	}
	if (ecad_mouse_mode == M_DRAW) {
		sprintf(gui_info, "Select: x=%0.1fmm, y=%0.1fmm", (float)event.button.x / 10.0, (float)event.button.y / 10.0);
		if (ecad_mover[ecad_mode] != NULL) {
			(*ecad_mover[ecad_mode])();
		}
	} else if (ecad_mouse_mode == M_SELECT) {
		if (event.button.button == 1) {
			ecad_move();
		} else if (event.button.button == 2) {
			int ecad_id;
			for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
				if (ECAD[ecad_id].view != 0) {
					if (ECAD[ecad_id].x1 == ecad_select_x1 && ECAD[ecad_id].y1 == ecad_select_y1) {
						ECAD[ecad_id].x1 = event.button.x;
						ECAD[ecad_id].y1 = event.button.y;
						break;
					} else if (ECAD[ecad_id].x2 == ecad_select_x1 && ECAD[ecad_id].y2 == ecad_select_y1) {
						ECAD[ecad_id].x2 = event.button.x;
						ECAD[ecad_id].y2 = event.button.y;
						break;
					}
				}
			}
			ecad_select_x1 = event.button.x;
			ecad_select_y1 = event.button.y;
			ecad_select_x2 = event.button.x;
			ecad_select_y2 = event.button.y;
		} else {
			int ecad_id = 0;
			sprintf(gui_info, "Koordinaten: x=%0.1fmm, y=%0.1fmm", (float)event.button.x / 10.0, (float)event.button.y / 10.0);
			ecad_select_num = -1;
			for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
				if (ECAD[ecad_id].view != 0 && ECAD[ecad_id].selected == 1) {
					if (ECAD[ecad_id].x1 == event.button.x && ECAD[ecad_id].y1 == event.button.y) {
						sprintf(gui_info, "Object: %s (%i)", ECAD[ecad_id].info, ecad_id);
						ecad_select_num = ecad_id;
						ecad_movemode = 0;
						ecad_select_x1 = event.button.x;
						ecad_select_y1 = event.button.y;
						ecad_select_x2 = event.button.x;
						ecad_select_y2 = event.button.y;
						return 0;
					} else if (ECAD[ecad_id].x2 == event.button.x && ECAD[ecad_id].y2 == event.button.y) {
						sprintf(gui_info, "Object: %s (%i)", ECAD[ecad_id].info, ecad_id);
						ecad_select_num = ecad_id;
						ecad_movemode = 1;
						ecad_select_x1 = event.button.x;
						ecad_select_y1 = event.button.y;
						ecad_select_x2 = event.button.x;
						ecad_select_y2 = event.button.y;
						return 0;
					}
				}
			}
		}
	} else {
		sprintf(gui_info, "Koordinaten: x=%0.1fmm, y=%0.1fmm", (float)event.button.x / 10.0, (float)event.button.y / 10.0);
	}
	return 0;
}

int ecad_image_mdown(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.x = ecad_unzoom_int(event.button.x);
	event.button.y = ecad_unzoom_int(event.button.y);
	if (ecad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
		event.button.y = ((int)((float)(event.button.y + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
	}
	if (event.button.button == 1) {
		if (ecad_mouse_mode == M_DRAW) {
			if (ecad_mdown[ecad_mode] != NULL) {
				(*ecad_mdown[ecad_mode])();
			}
		} else if (ecad_mouse_mode == M_SELECT) {
			ecad_select_x1 = event.button.x;
			ecad_select_y1 = event.button.y;
			ecad_select_x2 = ecad_select_x1;
			ecad_select_y2 = ecad_select_y1;
			sprintf(gui_info, "Move-Selection x=%i, y=%i", ecad_select_x2, ecad_select_y2);
			int ecad_id = 0;
			for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
				if (ECAD[ecad_id].view != 0) {
					if (ECAD[ecad_id].x1 == ecad_select_x1 && ECAD[ecad_id].y1 == ecad_select_y1) {
						sprintf(gui_info, "Select %s: x=%i, y=%i (%i)", ECAD[ecad_id].info, ecad_select_x1, ecad_select_y1, ecad_id);
						ECAD[ecad_id].selected = 1;
						ecad_active_id = ecad_id;
						ecad_movemode = 0;
					} else if (ECAD[ecad_id].x2 == ecad_select_x1 && ECAD[ecad_id].y2 == ecad_select_y1) {
						sprintf(gui_info, "Select %s: x=%i, y=%i (%i)", ECAD[ecad_id].info, ecad_select_x1, ecad_select_y1, ecad_id);
						ECAD[ecad_id].selected = 1;
						ecad_active_id = ecad_id;
						ecad_movemode = 1;
					} else {
						ECAD[ecad_id].selected = 0;
					}
				} else {
					ECAD[ecad_id].selected = 0;
				}
			}
		}
	} else if (event.button.button == 2) {
		ecad_select_delete();
	} else if (event.button.button == 3) {
		if (ecad_mouse_mode == M_DRAW) {
			ecad_clean_select();
		} else if (ecad_mouse_mode == M_SELECT) {
			ecad_select_x1 = event.button.x;
			ecad_select_y1 = event.button.y;
			ecad_select_x2 = ecad_select_x1;
			ecad_select_y2 = ecad_select_y1;
			sprintf(gui_info, "Start-Selection x=%i, y=%i", ecad_select_x1, ecad_select_y1);
		}
	} else if (event.button.button == 4) {
		if (ecad_zoom > 0.01) {
			ecad_zoom -= 0.01;
		}
	} else if (event.button.button == 5) {
		ecad_zoom += 0.01;
	}
	return 0;
}

int ecad_image_mup(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.x = ecad_unzoom_int(event.button.x);
	event.button.y = ecad_unzoom_int(event.button.y);
	if (ecad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
		event.button.y = ((int)((float)(event.button.y + (ecad_raster / 2)) / ecad_raster) * ecad_raster);
	}
	if (event.button.button == 1) {
		if (ecad_mouse_mode == M_DRAW) {
			if (ecad_mup[ecad_mode] != NULL) {
				(*ecad_mup[ecad_mode])();
			}
		} else if (ecad_mouse_mode == M_SELECT) {
			ecad_active_id = ecad_get_free_id();
		}
	} else if (event.button.button == 3) {
		if (ecad_mouse_mode == M_SELECT) {
			ecad_select_x2 = event.button.x;
			ecad_select_y2 = event.button.y;
			sprintf(gui_info, "End-Selection x=%i, y=%i", ecad_select_x2, ecad_select_y2);
			int ecad_id = 0;
			for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
				if (ECAD[ecad_id].view != 0) {
					if (ECAD[ecad_id].y1 >= ecad_select_y1 && ECAD[ecad_id].y1 <= ecad_select_y2) {
						if (ECAD[ecad_id].x1 >= ecad_select_x1 && ECAD[ecad_id].x1 <= ecad_select_x2) {
							sprintf(gui_info, "Entferne %s (%i)", ECAD[ecad_id].info, ecad_id);
							ecad_active_id = ecad_id;
							ecad_clean_select();
							if (ecad_select_x1 == ecad_select_x2 && ecad_select_y1 == ecad_select_y2) {
								ecad_select_x1 = 0;
								ecad_select_y1 = 0;
								ecad_select_x2 = 0;
								ecad_select_y2 = 0;
								return 0;
							}
						}
					}
				}
			}
			ecad_select_x1 = 0;
			ecad_select_y1 = 0;
			ecad_select_x2 = 0;
			ecad_select_y2 = 0;
		}
	}
	return 0;
}

int ecad_view_3d(void) {
	Widget[WidgetID[EXPORT_IMAGE]].type = 4;
	Widget[WidgetID[EXPORT_IMAGE]].view = 1 - Widget[WidgetID[EXPORT_IMAGE]].view;
	return 0;
}

int ecad_image_input(char *txt_str) {
	if (ecad_mouse_mode == M_DRAW) {
		if (ecad_input[ecad_mode] != NULL) {
			return (*ecad_input[ecad_mode])(txt_str);
		}
	}
	if (strcmp(txt_str, "left") == 0) {
		glRotatef(-9.0, 1.0, 1.0, 0.0);
	} else if (strcmp(txt_str, "right") == 0) {
		glRotatef(9.0, 1.0, 1.0, 0.0);
	}
	return -1;
}

int ecad_select_delete(void) {
	ecad_mouse_mode = M_SELECT;
	ecad_clean_select();
	gui_select_icon(WidgetID[DRAW_SELECT]);
	return 0;
}

int ecad_select_move(void) {
	ecad_mouse_mode = M_SELECT;
	ecad_clean_select();
	gui_select_icon(WidgetID[DRAW_MOVE]);
	return 0;
}

int ecad_init(void) {
	int ecad_id = 0;
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;
	ecad_mode = 0;
	ecad_mode = 0;
	ecad_select = 0;
	ecad_active_id = 0;
	ecad_export = 0;
	for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
		ECAD[ecad_id].type = 0;
		ECAD[ecad_id].x1 = 0;
		ECAD[ecad_id].y1 = 0;
		ECAD[ecad_id].x2 = 0;
		ECAD[ecad_id].y2 = 0;
		ECAD[ecad_id].rotate = 0;
		ECAD[ecad_id].size = 0;
		ECAD[ecad_id].dtype = 0;
		ECAD[ecad_id].mode = 0;
		ECAD[ecad_id].view = 0;
		ECAD[ecad_id].layer = 0;
		ECAD[ecad_id].group = 0;
		ECAD[ecad_id].selected = 0;
		ECAD[ecad_id].text[0] = 0;
		ECAD[ecad_id].info[0] = 0;
	}
	ecad_select_delete();
	ecad_clean_select();
	strcpy(ecad_filename, "Unnamed.ecad");
	return 0;
}


