
int ecad_select_box(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Box selected");
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_BOX;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_BOX]);
	}
	return 0;
}

int ecad_set_box(int mode, int layer, int x1, int y1, int x2, int y2, int line_size) {
	ECAD[ecad_active_id].type = DRAW_BOX;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x2;
	ECAD[ecad_active_id].y2 = y2;
	ECAD[ecad_active_id].size = line_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Box");
	return 0;
}

int ecad_draw_box(int ecad_id) {
	int size_n = 0;
	int r = 0;
	int g = 0;
	int b = 0;
	int a = 255;
	if (ecad_show_bottom_cu == 1) {
		boxRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].x2), ecad_zoom_int(ECAD[ecad_id].y2), bc_r, bc_g, bc_b, bc_a);
	}
	return 0;
}

int ecad_mdown_box(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_box(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
		}
	}
	return 0;
}

int ecad_mup_box(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_select = SELECT_XY2;
			ecad_set_box(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
		} else if (ecad_select == SELECT_XY2) {
			ecad_x2 = event.button.x;
			ecad_y2 = event.button.y;
			ecad_select = SELECT_XY1;
			ecad_set_box(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_box(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Box-Start-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_box(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
	} else if (ecad_select == SELECT_XY2) {
		ecad_x2 = event.button.x;
		ecad_y2 = event.button.y;
		sprintf(gui_info, "Box-End-Possition: x=%i, y=%i --> x=%i, y=%i (w=%i, h=%i)", ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_x2 - ecad_x1, ecad_y2 - ecad_y1);
		ecad_set_box(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
	}
	return 0;
}

int ecad_input_box(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strstr(tmp_str, ",") == 0 && (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0)) {
		tmp_str[str_ptr++] = ',';
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			if (ecad_select == SELECT_XY1) {
				ecad_x1 = atoi(tmp_str);
				ecad_y1 = atoi(loc + 1);
				ecad_x2 = ecad_x1;
				ecad_y2 = ecad_y1;
				ecad_select = SELECT_XY2;
				ecad_set_box(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
			} else if (ecad_select == SELECT_XY2) {
				ecad_x2 = atoi(tmp_str);
				ecad_y2 = atoi(loc + 1);
				ecad_select = SELECT_XY1;
				ecad_set_box(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
				ecad_active_id = ecad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (ecad_select == SELECT_XY1) {
		sprintf(gui_info, "Box-Start-Possition: x=?, y=? (%s)", tmp_str);
	} else if (ecad_select == SELECT_XY2) {
		sprintf(gui_info, "Box-End-Possition: x=%i, y=%i --> x=?, y=? (%s)", ecad_x1, ecad_y1, tmp_str);
	}
	return 0;
}


