
int ecad_select_lines(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Lines selected");
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_LINES;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_LINES]);
	} else if (event.button.button == 4) {
		ecad_linesize++;
		sprintf(gui_info, "Line-Size: %i", ecad_linesize);
	} else if (event.button.button == 5) {
		if (ecad_linesize > 1) {
			ecad_linesize--;
		}
		sprintf(gui_info, "Line-Size: %i", ecad_linesize);
	}
	return 0;
}

int ecad_set_lines(int mode, int layer, int x1, int y1, int x2, int y2, int line_size) {
	ECAD[ecad_active_id].type = DRAW_LINES;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x2;
	ECAD[ecad_active_id].y2 = y2;
	ECAD[ecad_active_id].size = line_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Leiterbahn");
	return 0;
}

int ecad_draw_lines(int ecad_id) {
	int size_n = 0;
	if (ecad_show_bottom_cu == 1) {
		for (size_n = 0; size_n < ecad_zoom_int(ECAD[ecad_id].size / 2); size_n++) {
			lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1) + size_n, ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].x2) + size_n, ecad_zoom_int(ECAD[ecad_id].y2), bc_r, bc_g, bc_b, bc_a);
			lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1) + size_n, ecad_zoom_int(ECAD[ecad_id].x2), ecad_zoom_int(ECAD[ecad_id].y2) + size_n, bc_r, bc_g, bc_b, bc_a);
		}
		for (size_n = 0; size_n < ecad_zoom_int(ECAD[ecad_id].size / 2); size_n++) {
			lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1) - size_n, ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].x2) - size_n, ecad_zoom_int(ECAD[ecad_id].y2), bc_r, bc_g, bc_b, bc_a);
			lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1) - size_n, ecad_zoom_int(ECAD[ecad_id].x2), ecad_zoom_int(ECAD[ecad_id].y2) - size_n, bc_r, bc_g, bc_b, bc_a);
		}
// 		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int((ECAD[ecad_id].size - 2) / 2), bc_r, bc_g, bc_b, bc_a);
// 		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x2), ecad_zoom_int(ECAD[ecad_id].y2), ecad_zoom_int((ECAD[ecad_id].size - 2) / 2), bc_r, bc_g, bc_b, bc_a);
		int x1 = ecad_zoom_int(ECAD[ecad_id].x1);
		int y1 = ecad_zoom_int(ECAD[ecad_id].y1);
		int x2 = ecad_zoom_int(ECAD[ecad_id].x2);
		int y2 = ecad_zoom_int(ECAD[ecad_id].y2);
		glBegin(GL_LINES);
		glColor3f(0.5, 0.5, 0.5);
		glVertex3f(x1, y1, 0.2);
		glVertex3f(x2, y2, 0.2);
		glColor3f(0.3, 0.3, 0.2);
		glVertex3f(x1, y1, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x2, y2, -200.0 * ecad_zoom - 0.2);
		glEnd();
	}
	return 0;
}

int ecad_mdown_lines(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
		}
	}
	return 0;
}

int ecad_mup_lines(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_select = SELECT_XY2;
			ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
		} else if (ecad_select == SELECT_XY2) {
			ecad_x2 = event.button.x;
			ecad_y2 = event.button.y;
			ecad_set_lines(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
			ecad_active_id = ecad_get_free_id();
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_select = SELECT_XY2;
			ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
		}
	}
	return 0;
}

int ecad_mover_lines(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Line-Start-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
	} else if (ecad_select == SELECT_XY2) {
		ecad_x2 = event.button.x;
		ecad_y2 = event.button.y;
		sprintf(gui_info, "Line-End-Possition: x=%i, y=%i --> x=%i, y=%i (w=%i, h=%i)", ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_x2 - ecad_x1, ecad_y2 - ecad_y1);
		ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
	}
	return 0;
}

int ecad_input_lines(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strstr(tmp_str, ",") == 0 && (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0)) {
		tmp_str[str_ptr++] = ',';
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			if (ecad_select == SELECT_XY1) {
				ecad_x1 = atoi(tmp_str);
				ecad_y1 = atoi(loc + 1);
				ecad_x2 = ecad_x1;
				ecad_y2 = ecad_y1;
				ecad_select = SELECT_XY2;
				ecad_set_lines(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
			} else if (ecad_select == SELECT_XY2) {
				ecad_x2 = atoi(tmp_str);
				ecad_y2 = atoi(loc + 1);
				ecad_select = SELECT_XY1;
				ecad_set_lines(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_linesize);
				ecad_active_id = ecad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (ecad_select == SELECT_XY1) {
		sprintf(gui_info, "Line-Start-Possition: x=?, y=? (%s)", tmp_str);
	} else if (ecad_select == SELECT_XY2) {
		sprintf(gui_info, "Line-End-Possition: x=%i, y=%i --> x=?, y=? (%s)", ecad_x1, ecad_y1, tmp_str);
	}
	return 0;
}


