
#include "serial.c"
#include "cnc-interface.h"
#include "cnc-output_hpgl.c"
#include "cnc-output_mxm.c"
#include "cnc-output_preview.c"
#include "cnc-output_gcode.c"
#include "cnc-output_dxf.c"



int cnc_check_z(void) {
	return (*cncout_check_z[cncout])();
}

int cnc_set_speed_xy(int speed) {
	return (*cncout_set_speed_xy[cncout])(speed);
}

int cnc_set_speed_z(int speed) {
	return (*cncout_set_speed_z[cncout])(speed);
}

int cnc_reset(void) {
	return (*cncout_reset[cncout])();
}

int cnc_start(int x, int y) {
	return (*cncout_start[cncout])(x, y);
}

int cnc_stop(void) {
	return (*cncout_stop[cncout])();
}

int cnc_off(void) {
	return (*cncout_off[cncout])();
}

int cnc_tool_change(int tool_nr) {
	return (*cncout_tool_change[cncout])(tool_nr);
}

int cnc_soft_start(int value) {
	return (*cncout_soft_start[cncout])(value);
}

int cnc_go_xy(int x, int y) {
	return (*cncout_go_xy[cncout])(x, y);
}

int cnc_go_x(int x) {
	return (*cncout_go_x[cncout])(x);
}

int cnc_go_y(int y) {
	return (*cncout_go_y[cncout])(y);
}

int cnc_go_z(int z) {
	return (*cncout_go_z[cncout])(z);
}

int cnc_drill_on(void) {
	return (*cncout_drill_on[cncout])();
}

int cnc_drill_off(void) {
	return (*cncout_drill_off[cncout])();
}

int cnc_drill_set_speed(int speed) {
	return (*cncout_drill_set_speed[cncout])(speed);
}

int cnc_drill(void) {
	return (*cncout_drill[cncout])();
}

int cnc_pen(int updown) {
	return (*cncout_pen[cncout])(updown);
}




int cnc_init(void) {
	cnc_tool_active = 0;
	cnc_zover = 30;

	XAxis[0].scale = 2.5;		// (Steigung = 0.80mm/U bei 200 S/U)
	XAxis[0].offset = 4000;
	XAxis[0].speed = 255;
	XAxis[0].axis = 0;
	XAxis[0].type = 0;

	XAxis[1].scale = 2.5;
	XAxis[1].offset = 0;
	XAxis[1].speed = 255;
	XAxis[1].axis = 2;
	XAxis[1].type = 1;

	YAxis[0].scale = 2.5;
	YAxis[0].offset = 4100;
	YAxis[0].speed = 255;
	YAxis[0].axis = 1;
	YAxis[0].type = 0;

	ZAxis[0].offset_x = 0;			// X-Diff in mm/100
	ZAxis[0].offset_y = 4400;		// Y-Diff in mm/100
	ZAxis[0].offset_z = 4900;		// Z-Diff in mm/100
	ZAxis[0].axis = 2;			// Achsen-Nummer
	ZAxis[0].speed = 255;			// Achsen-Speed
	ZAxis[0].type = 0;			// Typ des Achen-Antriebs (0=Stepper, 1=Servo)
	ZAxis[0].scale = 0.6;			// Achsen-Scale (Stepps/0.1mm -- Steigung = 0.80mm/U bei 48 S/U))
	ZAxis[0].tool.speed = 255;		// Drehzahl des Frskopfes
	ZAxis[0].tool.delay = 2;		// Wartezeit nach anschalten des Stiftes/Frskopfes
	ZAxis[0].tool.type  = 1;		// Typ des Werkzeugs (0=Stift, 1=Frs-Motor)
	ZAxis[0].tool.head.radius = 10;		// Radius des Stiftes/Frskopfes mm/100
	ZAxis[0].tool.head.type = 4;		// Form des Frskopfes

	ZAxis[1].offset_x = 0;
	ZAxis[1].offset_y = 0;
	ZAxis[1].offset_z = 5000;
	ZAxis[1].axis = 5;
	ZAxis[1].speed = 255;
	ZAxis[1].type = 1;
	ZAxis[1].scale = 2.0;
	ZAxis[1].tool.speed = 255;
	ZAxis[1].tool.delay = 3;
	ZAxis[1].tool.type  = 1;
	ZAxis[1].tool.head.radius = 30;
	ZAxis[1].tool.head.type = 5;

	cnc_material_num = 0;
	strcpy(Material[cnc_material_num].name, "User-Defined");
	Material[cnc_material_num].speed = 255;
	Material[cnc_material_num].m_speed = 255;
	Material[cnc_material_num].z_steps = 10;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "Aluminium (Weich)");
	Material[cnc_material_num].speed = 200;
	Material[cnc_material_num].m_speed = 255;
	Material[cnc_material_num].z_steps = 4;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "Aluminium (Hart)");
	Material[cnc_material_num].speed = 155;
	Material[cnc_material_num].m_speed = 255;
	Material[cnc_material_num].z_steps = 2;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "Polystyrol");
	Material[cnc_material_num].speed = 210;
	Material[cnc_material_num].m_speed = 50;
	Material[cnc_material_num].z_steps = 5;
	cnc_material_num++;
	
	strcpy(Material[cnc_material_num].name, "Balsa-Holz");
	Material[cnc_material_num].speed = 250;
	Material[cnc_material_num].m_speed = 255;
	Material[cnc_material_num].z_steps = 10;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "Styropor");
	Material[cnc_material_num].speed = 255;
	Material[cnc_material_num].m_speed = 215;
	Material[cnc_material_num].z_steps = 30;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "Styrodur");
	Material[cnc_material_num].speed = 255;
	Material[cnc_material_num].m_speed = 225;
	Material[cnc_material_num].z_steps = 30;
	cnc_material_num++;

	strcpy(Material[cnc_material_num].name, "");
	cnc_material_num = 0;

	cncout = 4;
	cncout_preview_init(0);
	cncout_hpgl_init(1);
	cncout_mxm_init(2);
	cncout_gcode_init(3);
	cncout_dxf_init(4);

	if (serial_open() != 0) {
		return 1;
	}

	return 0;
}

int cnc_load_config(void) {
	FILE *stream;
	char read_line[256];
	if ((stream = fopen("/tmp/test.setup", "r")) != 0) {
		while(!feof(stream)) {
			read_line[0] = 0;
			fgets(read_line, 255, stream);
			if (strncmp(read_line, "PEN_SIZE=", 9) == 0) {
// 				z_stop = atoi(read_line + 7);
			}
		}
		fclose(stream);
	}
	return 0;
}

