
FILE *cncout_gcode_stream = NULL;
int prog_num = 1;

int cncout_gcode_check_z(void) {
	return 0;
}

int cncout_gcode_set_speed_xy(int speed) {
	return 0;
}

int cncout_gcode_set_speed_z(int speed) {
	return 0;
}

int cncout_gcode_soft_start(int value) {
	return 0;
}

int cncout_gcode_reset(void) {
	fprintf(cncout_gcode_stream, "N%i G90\n", prog_num++);
	fprintf(cncout_gcode_stream, "N%i G00 Z40.0\n", prog_num++);
	fprintf(cncout_gcode_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	return 0;
}

int cncout_gcode_start(int x, int y) {
	if ((cncout_gcode_stream = fopen("/tmp/gcode-out.cnc", "w")) != 0) {
		prog_num = 1;
		fprintf(cncout_gcode_stream, "%%1\n");
		fprintf(cncout_gcode_stream, "(ZEICHNUNGS-DATEI: %s)\n", basename(ecad_filename));
		fprintf(cncout_gcode_stream, "(WERKZEUGDURCHMESSER %0.1f mm)\n", (float)ZAxis[cnc_tool_active].tool.head.radius * 2 / 10.0);
		fprintf(cncout_gcode_stream, "N%i G90\n", prog_num++);
		cncout_gcode_reset();
		cnc_active = 1;
	} else {
		cncout_gcode_stream = NULL;
		cnc_active = 0;
	}
	return 0;
}

int cncout_gcode_stop(void) {
	fprintf(cncout_gcode_stream, "N%i G00 Z40.0\n", prog_num++);
	fprintf(cncout_gcode_stream, "N%i M5\n", prog_num++);
	fprintf(cncout_gcode_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	fprintf(cncout_gcode_stream, "N%i M30\n", prog_num++);
	fprintf(cncout_gcode_stream, "\n");
	if (cncout_gcode_stream != NULL) {
		fclose(cncout_gcode_stream);
	}
	cnc_active = 0;
	return 0;
}

int cncout_gcode_off(void) {
	fprintf(cncout_gcode_stream, "N%i M5\n", prog_num++);
	return 0;
}

int cncout_gcode_tool_change(int tool_nr) {
	return 0;
}

int cncout_gcode_go_xy(int x, int y) {
	fprintf(cncout_gcode_stream, "N%i X%0.1f Y%0.1f\n", prog_num++, (float)x / 10.0, (float)y / 10.0);
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_gcode_go_x(int x) {
	fprintf(cncout_gcode_stream, "N%i X%0.1f\n", prog_num++, (float)x / 10.0);
	cnc_last_x = x;
	return 0;
}

int cncout_gcode_go_y(int y) {
	fprintf(cncout_gcode_stream, "N%i Y%0.1f\n", prog_num++, (float)y / 10.0);
	cnc_last_y = y;
	return 0;
}

int cncout_gcode_go_z(int pos_z) {
	fprintf(cncout_gcode_stream, "N%i Z%0.1f\n", prog_num++, (float)pos_z / 10.0);
	cnc_last_z = pos_z;
	cnc_last_tool_offset = ZAxis[cnc_tool_active].offset_z;
	return 0;
}

int cncout_gcode_drill_on(void) {
	fprintf(cncout_gcode_stream, "N%i M3\n", prog_num++);
	return 0;
}

int cncout_gcode_drill_off(void) {
	fprintf(cncout_gcode_stream, "N%i M5\n", prog_num++);
	return 0;
}

int cncout_gcode_drill_set_speed(int speed) {
	return 0;
}

int cncout_gcode_drill(void) {
	return 0;
}

int cncout_gcode_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			fprintf(cncout_gcode_stream, "N%i G00 Z40.0\n", prog_num++);
			cnc_last_updown = updown;
		} else if (updown == 2) {
			fprintf(cncout_gcode_stream, "N%i G01 Z%0.1f\n", prog_num++, (float)z_stop / 10.0);
			cnc_last_updown = 1;
		} else if (updown == 1) {
			fprintf(cncout_gcode_stream, "N%i G00 Z%0.1f\n", prog_num++, (float)z_stop / 10.0);
			cnc_last_updown = updown;
		} else if (updown == 0) {
			fprintf(cncout_gcode_stream, "N%i G00 Z%0.1f\n", prog_num++, (float)z_start / 10.0);
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_gcode_init(int num) {
	cncout_check_z[num] = cncout_gcode_check_z;
	cncout_set_speed_xy[num] = cncout_gcode_set_speed_xy;
	cncout_set_speed_z[num] = cncout_gcode_set_speed_z;
	cncout_reset[num] = cncout_gcode_reset;
	cncout_start[num] = cncout_gcode_start;
	cncout_stop[num] = cncout_gcode_stop;
	cncout_off[num] = cncout_gcode_off;
	cncout_tool_change[num] = cncout_gcode_tool_change;
	cncout_soft_start[num] = cncout_gcode_soft_start;
	cncout_go_xy[num] = cncout_gcode_go_xy;
	cncout_go_x[num] = cncout_gcode_go_x;
	cncout_go_y[num] = cncout_gcode_go_y;
	cncout_go_z[num] = cncout_gcode_go_z;
	cncout_drill_on[num] = cncout_gcode_drill_on;
	cncout_drill_off[num] = cncout_gcode_drill_off;
	cncout_drill_set_speed[num] = cncout_gcode_drill_set_speed;
	cncout_drill[num] = cncout_gcode_drill;
	cncout_pen[num] = cncout_gcode_pen;
	strcpy(cncout_name[num], "G-Code-Output");
	return 0;
}


