
int cncout_mxm_check_z(void) {
	char tmp_str[256];
	char tmp_str2[256];

	serial_send("R5\n");
	serial_send("R4\n");
	serial_send("R2\n");
	serial_send("R1\n");

	sprintf(tmp_str, "A%i=%i\n", YAxis[0].axis, (int)((float)(ZAxis[cnc_tool_active].offset_y) * YAxis[0].scale));
	serial_send(tmp_str);
	sprintf(tmp_str, "W%i\n", ZAxis[cnc_tool_active].axis);
	serial_send_receive(tmp_str, tmp_str2);
	ZAxis[cnc_tool_active].offset_z = (int)((float)(atoi(tmp_str2)) / ZAxis[cnc_tool_active].scale);
	fprintf(stderr, "REP: %0.1f mm\n", (float)(ZAxis[cnc_tool_active].offset_z) / 10.0);

	return 0;
}

int cncout_mxm_set_speed_xy(int speed) {
	char cmd[25];
	sprintf(cmd, "S%i=%i\n", XAxis[0].axis, speed);
	serial_send(cmd);
	sprintf(cmd, "S%i=%i\n", YAxis[0].axis, speed);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_set_speed_z(int speed) {
	char cmd[25];
	sprintf(cmd, "S%i=%i\n", ZAxis[cnc_tool_active].axis, speed);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_soft_start(int value) {
	char cmd[25];
	sprintf(cmd, "F=%i\n", value);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_reset(void) {
	char cmd[4];
	sprintf(cmd, "R%i\n", ZAxis[0].axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", ZAxis[1].axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", XAxis[0].axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", YAxis[0].axis);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_start(int x, int y) {
	cnc_set_speed_xy(255);
	cnc_set_speed_z(255);
	cnc_active = 1;
	return 0;
}

int cncout_mxm_stop(void) {
	cnc_set_speed_xy(255);
	cnc_set_speed_z(255);
	cnc_go_z(0);
	cnc_drill_off();
	cnc_go_xy(0, 0);
	cncout_mxm_off();
	cnc_active = 0;
	return 0;
}

int cncout_mxm_off(void) {
	serial_send("O\n");
	return 0;
}

int cncout_mxm_tool_change(int tool_nr) {
	cnc_set_speed_xy(255);
	cnc_go_z(0);
	cnc_drill_off();
	cnc_tool_active = tool_nr;
	cnc_go_z(0);
	return 0;
}

int cncout_mxm_go_xy(int x, int y) {
	char cmd[256];
	sprintf(cmd, "A%i=%i,%i=%i\n", XAxis[0].axis, (int)((float)(x + ZAxis[cnc_tool_active].offset_x + XAxis[0].offset) * XAxis[0].scale), YAxis[0].axis, (int)((float)(y + ZAxis[cnc_tool_active].offset_y + YAxis[0].offset) * YAxis[0].scale));
	serial_send(cmd);
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_mxm_go_x(int x) {
	char cmd[256];
	sprintf(cmd, "A%i=%i\n", XAxis[0].axis, (int)((float)(x + ZAxis[cnc_tool_active].offset_x + XAxis[0].offset) * XAxis[0].scale));
	serial_send(cmd);
	cnc_last_x = x;
	return 0;
}

int cncout_mxm_go_y(int y) {
	char cmd[256];
	sprintf(cmd, "A%i=%i\n", YAxis[0].axis, (int)((float)(y + ZAxis[cnc_tool_active].offset_y + YAxis[0].offset) * YAxis[0].scale));
	serial_send(cmd);
	cnc_last_y = y;
	return 0;
}

int cncout_mxm_go_z(int pos_z) {
	char cmd[256];
// 	if (cnc_last_z != pos_z || ZAxis[cnc_tool_active].offset_z != cnc_last_tool_offset) {
		sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)pos_z * ZAxis[cnc_tool_active].scale));
		serial_send(cmd);
// 	}
	cnc_last_z = pos_z;
	cnc_last_tool_offset = ZAxis[cnc_tool_active].offset_z;
	return 0;
}

int cncout_mxm_drill_on(void) {
	char cmd[256];
	sprintf(cmd, "M0=%i\n", ZAxis[cnc_tool_active].tool.speed);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_drill_off(void) {
	serial_send("M0=0\n");
	return 0;
}

int cncout_mxm_drill_set_speed(int speed) {
	char cmd[256];
	sprintf(cmd, "M0=%i\n", speed);
	serial_send(cmd);
	return 0;
}

int cncout_mxm_drill(void) {
	cnc_set_speed_z(255);
	cnc_go_z(z_start - 10);
	cnc_drill_on();
	cnc_set_speed_z(ZAxis[cnc_tool_active].speed);
/*	if (z_stop - z_start > 50) {
		cnc_go_z(z_start + ((z_stop - z_start) / 2));
		usleep(10000);
		cnc_set_speed_z(255);
		cnc_go_z(z_start + ((z_stop - z_start) / 2) - 15);
		usleep(20000);
		cnc_set_speed_z(speed_z);
		cnc_go_z(z_start + ((z_stop - z_start) / 2));
	}*/
	cnc_go_z(z_stop);
	sleep(1);
	cnc_set_speed_z(255);
	cnc_go_z(z_start);
	cnc_drill_off();
// 	cnc_go_z(0);
	return 0;
}

int cncout_mxm_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, 0);
			serial_send(cmd);
			cnc_last_updown = updown;
		} else if (updown == 2) {
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)(z_stop + ZAxis[cnc_tool_active].offset_z) * ZAxis[cnc_tool_active].scale));
			serial_send(cmd);
			sleep(3);
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)(z_start + ZAxis[cnc_tool_active].offset_z) * ZAxis[cnc_tool_active].scale));
			serial_send(cmd);
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_set_speed_z(255);
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)(z_start + ZAxis[cnc_tool_active].offset_z) * ZAxis[cnc_tool_active].scale));
			serial_send(cmd);
			cnc_set_speed_z(ZAxis[cnc_tool_active].speed);
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)(z_stop + ZAxis[cnc_tool_active].offset_z) * ZAxis[cnc_tool_active].scale));
			serial_send(cmd);
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_set_speed_z(255);
			sprintf(cmd, "A%i=%i\n", ZAxis[cnc_tool_active].axis, (int)((float)(z_start + ZAxis[cnc_tool_active].offset_z) * ZAxis[cnc_tool_active].scale));
			serial_send(cmd);
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_mxm_init(int num) {
	cncout_check_z[num] = cncout_mxm_check_z;
	cncout_set_speed_xy[num] = cncout_mxm_set_speed_xy;
	cncout_set_speed_z[num] = cncout_mxm_set_speed_z;
	cncout_reset[num] = cncout_mxm_reset;
	cncout_start[num] = cncout_mxm_start;
	cncout_stop[num] = cncout_mxm_stop;
	cncout_off[num] = cncout_mxm_off;
	cncout_tool_change[num] = cncout_mxm_tool_change;
	cncout_soft_start[num] = cncout_mxm_soft_start;
	cncout_go_xy[num] = cncout_mxm_go_xy;
	cncout_go_x[num] = cncout_mxm_go_x;
	cncout_go_y[num] = cncout_mxm_go_y;
	cncout_go_z[num] = cncout_mxm_go_z;
	cncout_drill_on[num] = cncout_mxm_drill_on;
	cncout_drill_off[num] = cncout_mxm_drill_off;
	cncout_drill_set_speed[num] = cncout_mxm_drill_set_speed;
	cncout_drill[num] = cncout_mxm_drill;
	cncout_pen[num] = cncout_mxm_pen;
	strcpy(cncout_name[num], "mXm-CNC Interface v0.5");
	return 0;
}

