
#define M_NONE        0
#define M_SELECT      1
#define M_DRAW        2

#define SELECT_XY1    0
#define SELECT_XY2    1
#define SELECT_SIZE   2
#define SELECT_ROTATE 3
#define SELECT_TEXT   4

#define ECAD_MAX      10000

typedef struct {
	int type;
	int x1;
	int y1;
	int x2;
	int y2;
	int rotate;
	int size;
	int dtype;
	int mode;
	int view;
	int layer;
	int group;
	int selected;
	char text[512];
	char info[64];
} Ecad_Element;
Ecad_Element ECAD[ECAD_MAX];

SDL_Surface *ECAD_Surface;

int (*ecad_drawit[ECAD_MAX]) (int ecad_id);
int (*ecad_mover[ECAD_MAX]) (void);
int (*ecad_mdown[ECAD_MAX]) (void);
int (*ecad_mup[ECAD_MAX]) (void);
int (*ecad_input[ECAD_MAX]) (char *txt_str);
char ecad_filename[512];
int ecad_active_id = 0;
int ecad_active_layer = 0;
int ecad_mouse_mode = 0;
int ecad_mode = 0;
int ecad_select = 0;
int ecad_x1 = 0;
int ecad_y1 = 0;
int ecad_x2 = 0;
int ecad_y2 = 0;
int ecad_rotate = 0;
int ecad_padtype = 0;
int ecad_mounttype = 0;
int ecad_resistortype = 0;
float ecad_raster_snap = 1;
float ecad_raster_view = 1;
int ecad_select_x1 = 0;
int ecad_select_y1 = 0;
int ecad_select_x2 = 0;
int ecad_select_y2 = 0;
int ecad_select_num = 0;
int ecad_export = 0;
int ecad_movemode = 0;
int ecad_group_id = 1;

float ecad_zoom = 0.2;
float ecad_raster = 127;
int ecad_linesize = 50;
int ecad_textsize = 110;
int ecad_padsize = 180;
int ecad_mountsize = 200;

int ecad_show_top_label = 1;
int ecad_show_bottom_cu = 1;
int ecad_show_drill = 1;

int bc_r = 0;
int bc_g = 0;
int bc_b = 0;
int bc_a = 0;
int tl_r = 0;
int tl_g = 0;
int tl_b = 0;
int tl_a = 0;
int d_r = 0;
int d_g = 0;
int d_b = 0;
int d_a = 0;


int ecad_add_pad(int x1, int y1, int size, int dtype);
int ecad_zoom_int(int value);
int ecad_unzoom_int(int value);
int ecad_clean_select(void);
int ecad_file_load(char *filename);
int ecad_file_save(char *filename);
int ecad_get_free_id(void);
int ecad_toggle_show_top_label(void);
int ecad_toggle_show_bottom_cu(void);
int ecad_toggle_show_drill(void);
int ecad_set_color(int ecad_id);
int ecad_draw(void);
int ecad_image_raster_snap(void);
int ecad_image_raster_view(void);
int ecad_image_mover(void);
int ecad_image_mdown(void);
int ecad_image_mup(void);
int ecad_image_input(char *txt_str);
int ecad_select_delete(void);
int ecad_init(void);
