
int ecad_select_gnd(void) {
	if (event.button.button == 1) {
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_GND;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_GND]);
		sprintf(gui_info, "GND selected");
	}
	return 0;
}

int ecad_set_gnd(int mode, int layer, int x1, int y1) {
	ECAD[ecad_active_id].type = DRAW_GND;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x1;
	ECAD[ecad_active_id].y2 = y1;
	ECAD[ecad_active_id].size = 0;
	ECAD[ecad_active_id].dtype = 0;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Masse/GND");
	return 0;
}

int ecad_draw_gnd(int ecad_id) {
	SDL_Rect dstrect;
	SDL_Surface *text_img = NULL;
	SDL_Color color;
// 	if (ecad_show_top_label == 1 || ecad_mouse_mode == M_SELECT) {
	if (ecad_show_top_label == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), 2, 0, 0, 255, 255);
		color.r = tl_r;
		color.g = tl_g;
		color.b = tl_b;
		if ((text_img = TTF_RenderText_Solid(Stat_Font, ECAD[ecad_id].info, color)) != NULL) {
			dstrect.x = ecad_zoom_int(ECAD[ecad_id].x1 + 10);
			dstrect.y = ecad_zoom_int(ECAD[ecad_id].y1 + 10);
			dstrect.w = text_img->w;
			dstrect.h = text_img->h;
			SDL_BlitSurface(text_img, NULL, ECAD_Surface, &dstrect);
			SDL_FreeSurface(text_img);
		}
	}
	return 0;
}

int ecad_mdown_gnd(void) {
	return 0;
}

int ecad_mup_gnd(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_gnd(1, ecad_active_layer, ecad_x1, ecad_y1);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_gnd(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "GND-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_gnd(0, ecad_active_layer, ecad_x1, ecad_y1);
	}
	return 0;
}

int ecad_input_gnd(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			ecad_x1 = atoi(tmp_str);
			ecad_y1 = atoi(loc + 1);
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_gnd(1, ecad_active_layer, ecad_x1, ecad_y1);
			ecad_active_id = ecad_get_free_id();
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	frontend_draw_info(tmp_str);
	return 0;
}


