
int ecad_select_mount(void) {
	if (event.button.button == 1) {
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_MOUNT;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_MOUNT]);
		sprintf(gui_info, "Mount selected");
	} else if (event.button.button == 3) {
		ecad_mounttype = 1 - ecad_mounttype;
		if (ecad_mounttype == 0) {
			gui_update_icon(WidgetID[DRAW_MOUNT], "circle", -1, -1);
			sprintf(gui_info, "Mount-Type 1 selected");
		} else {
			gui_update_icon(WidgetID[DRAW_MOUNT], "circle-filled", -1, -1);
			sprintf(gui_info, "Mount-Type 2 selected");
		}
	}
	return 0;
}

int ecad_set_mount(int mode, int layer, int x1, int y1, int mount_size, int rotate) {
	ECAD[ecad_active_id].type = DRAW_MOUNT;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x1;
	ECAD[ecad_active_id].y2 = y1;
	ECAD[ecad_active_id].size = mount_size;
	ECAD[ecad_active_id].dtype = ecad_mounttype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Bohrung");
	return 0;
}

int ecad_draw_mount(int ecad_id) {
	int x1 = 0;
	int y1 = 0;
	int x2 = 0;
	int y2 = 0;
	if (ecad_show_bottom_cu == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].size), bc_r, bc_g, bc_b, bc_a);
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 - ECAD[ecad_id].size);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 - ECAD[ecad_id].size);
		x2 = ecad_zoom_int(ECAD[ecad_id].x1 + ECAD[ecad_id].size);
		y2 = ecad_zoom_int(ECAD[ecad_id].y1 + ECAD[ecad_id].size);
		glBegin(GL_QUADS);
		glColor3f(0.5, 0.5, 0.5);
		glVertex3f(x1, y1, 0.2);
		glVertex3f(x2, y1, 0.2);
		glVertex3f(x2, y2, 0.2);
		glVertex3f(x1, y2, 0.2);
		glColor3f(0.3, 0.3, 0.2);
		glVertex3f(x1, y1, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x2, y1, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x2, y2, -200.0 * ecad_zoom - 0.2);
		glVertex3f(x1, y2, -200.0 * ecad_zoom - 0.2);
		glEnd();
	}
	if (ecad_show_bottom_cu == 1 && ecad_show_drill == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int((ECAD[ecad_id].size / 2)), 0, 0, 0, 255);
	} else if (ecad_show_drill == 1) {
		filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int((ECAD[ecad_id].size / 2)), d_r, d_g, d_b, d_a);
	}
	if (ecad_show_top_label == 1) {
		if (ECAD[ecad_id].dtype == 0) {
			circleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].size / 3 * 2), tl_r, tl_g, tl_b, tl_a);
		} else {
			filledCircleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].size / 3 * 2), tl_r, tl_g, tl_b, tl_a);
		}
		lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1 - ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].y1 - ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].x1 + ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].y1 + ECAD[ecad_id].size), tl_r, tl_g, tl_b, tl_a);
		lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1 + ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].y1 - ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].x1 - ECAD[ecad_id].size), ecad_zoom_int(ECAD[ecad_id].y1 + ECAD[ecad_id].size), tl_r, tl_g, tl_b, tl_a);
	}
	if (ecad_show_drill == 1) {
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 - (ECAD[ecad_id].size / 2));
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 - (ECAD[ecad_id].size / 2));
		x2 = ecad_zoom_int(ECAD[ecad_id].x1 + (ECAD[ecad_id].size / 2));
		y2 = ecad_zoom_int(ECAD[ecad_id].y1 + (ECAD[ecad_id].size / 2));
		glBegin(GL_QUADS);
		glColor3f(0.0, 0.0, 0.0);
		glVertex3f(x1, y1, 0.4);
		glVertex3f(x2, y1, 0.4);
		glVertex3f(x2, y2, 0.4);
		glVertex3f(x1, y2, 0.4);
		glVertex3f(x1, y1, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x2, y1, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x2, y2, -200.0 * ecad_zoom - 0.4);
		glVertex3f(x1, y2, -200.0 * ecad_zoom - 0.4);
		glEnd();
	}
	return 0;
}

int ecad_mdown_mount(void) {
	return 0;
}

int ecad_mup_mount(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_mount(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_mountsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_mount(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Bohr-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_mount(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_mountsize, ecad_rotate);
	}
	return 0;
}

int ecad_input_mount(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			ecad_x1 = atoi(tmp_str);
			ecad_y1 = atoi(loc + 1);
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_mount(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_mountsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	frontend_draw_info(tmp_str);
	return 0;
}


