
int ecad_select_pad(void) {
	if (event.button.button == 1) {
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_PAD;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_PAD]);
		sprintf(gui_info, "Pad selected");
	} else if (event.button.button == 3) {
		ecad_padtype = 1 - ecad_padtype;
		if (ecad_padtype == 0) {
			gui_update_icon(WidgetID[DRAW_PAD], "point", -1, -1);
			sprintf(gui_info, "Quad-Pad selected");
		} else {
			gui_update_icon(WidgetID[DRAW_PAD], "point-round", -1, -1);
			sprintf(gui_info, "Round-Pad selected");
		}
	} else if (event.button.button == 4) {
		ecad_padsize++;
		sprintf(gui_info, "Pad-Size: %i", ecad_padsize);
	} else if (event.button.button == 5) {
		if (ecad_padsize > 1) {
			ecad_padsize--;
		}
		sprintf(gui_info, "Pad-Size: %i", ecad_padsize);
	}
	return 0;
}

int ecad_set_pad(int mode, int layer, int x1, int y1, int pad_size, int rotate) {
	ECAD[ecad_active_id].type = DRAW_PAD;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x1;
	ECAD[ecad_active_id].y2 = y1;
	ECAD[ecad_active_id].size = pad_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Ltpunkt");
	return 0;
}

int ecad_draw_pad(int ecad_id) {
	ecad_add_pad(ECAD[ecad_id].x1, ECAD[ecad_id].y1, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
	return 0;
}

int ecad_mdown_pad(void) {
	return 0;
}

int ecad_mup_pad(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_pad(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_pad(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Pad-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_pad(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
	}
	return 0;
}

int ecad_input_pad(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			ecad_x1 = atoi(tmp_str);
			ecad_y1 = atoi(loc + 1);
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_pad(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	frontend_draw_info(tmp_str);
	return 0;
}


