
int ecad_select_resistor(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Resistor selected");
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_RESISTOR;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_RESISTOR]);
	} else if (event.button.button == 4) {
		ecad_padsize++;
		sprintf(gui_info, "Resistor-Size: %i", ecad_padsize);
	} else if (event.button.button == 5) {
		if (ecad_padsize > 1) {
			ecad_padsize--;
		}
		sprintf(gui_info, "Resistor-Size: %i", ecad_padsize);
	}
	return 0;
}

int ecad_set_resistor(int mode, int layer, int x1, int y1, int x2, int y2, int resistor_size) {
	ECAD[ecad_active_id].type = DRAW_RESISTOR;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x2;
	ECAD[ecad_active_id].y2 = y2;
	ECAD[ecad_active_id].size = resistor_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Wiederstand");
	return 0;
}

int ecad_draw_resistor(int ecad_id) {
	int x1;
	int y1;
	int x2;
	int y2;
	int size_n = 0;
	ecad_add_pad(ECAD[ecad_id].x1, ECAD[ecad_id].y1, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
	ecad_add_pad(ECAD[ecad_id].x2, ECAD[ecad_id].y2, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
	if (ecad_show_top_label == 1) {
		lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), ecad_zoom_int(ECAD[ecad_id].x2), ecad_zoom_int(ECAD[ecad_id].y2), tl_r, tl_g, tl_b, tl_a);
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 + 100);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 + 100);
		x2 = ecad_zoom_int(ECAD[ecad_id].x2 - 100);
		y2 = ecad_zoom_int(ECAD[ecad_id].y2 - 100);
		glBegin(GL_QUADS);
		glColor4f(tl_r / 255, tl_g / 255, tl_b / 255, 1.0);
		glVertex3f(x1, y1, 336.0 * ecad_zoom);
		glVertex3f(x2, y1, 336.0 * ecad_zoom);
		glVertex3f(x2, y2, 336.0 * ecad_zoom);
		glVertex3f(x1, y2, 336.0 * ecad_zoom);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y1, 336.0 * ecad_zoom);
		glVertex3f(x2, y1, 336.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x1, y1, 2.0);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y2, 336.0 * ecad_zoom);
		glVertex3f(x2, y2, 336.0 * ecad_zoom);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x1, y2, 2.0);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x2, y1, 336.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x2, y2, 336.0 * ecad_zoom);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y1, 336.0 * ecad_zoom);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x1, y2, 336.0 * ecad_zoom);
		glEnd();
		x1 = ecad_zoom_int(ECAD[ecad_id].x1);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1);
		x2 = ecad_zoom_int(ECAD[ecad_id].x2);
		y2 = ecad_zoom_int(ECAD[ecad_id].y2);
		glBegin(GL_LINES);
		glColor3f(0.3, 0.3, 0.2);
		glVertex3f(x1, y1, 0.0);
		glVertex3f(x1, y1, 16.0);
		glVertex3f(x1, y1, 16.0);
		glVertex3f(x2, y2, 16.0);
		glVertex3f(x2, y2, 16.0);
		glVertex3f(x2, y2, 0.0);
		glEnd();
	}
	return 0;
}

int ecad_mdown_resistor(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_resistor(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
		}
	}
	return 0;
}

int ecad_mup_resistor(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_select = SELECT_XY2;
			ecad_set_resistor(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
		} else if (ecad_select == SELECT_XY2) {
			ecad_x2 = event.button.x;
			ecad_y2 = event.button.y;
			ecad_select = SELECT_XY1;
			ecad_set_resistor(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_resistor(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Resistor-Start-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_resistor(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
	} else if (ecad_select == SELECT_XY2) {
		ecad_x2 = event.button.x;
		ecad_y2 = event.button.y;
		sprintf(gui_info, "Resistor-End-Possition: x=%i, y=%i --> x=%i, y=%i (w=%i, h=%i)", ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_x2 - ecad_x1, ecad_y2 - ecad_y1);
		ecad_set_resistor(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
	}
	return 0;
}

int ecad_input_resistor(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strstr(tmp_str, ",") == 0 && (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0)) {
		tmp_str[str_ptr++] = ',';
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			if (ecad_select == SELECT_XY1) {
				ecad_x1 = atoi(tmp_str);
				ecad_y1 = atoi(loc + 1);
				ecad_x2 = ecad_x1;
				ecad_y2 = ecad_y1;
				ecad_select = SELECT_XY2;
				ecad_set_resistor(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
			} else if (ecad_select == SELECT_XY2) {
				ecad_x2 = atoi(tmp_str);
				ecad_y2 = atoi(loc + 1);
				ecad_select = SELECT_XY1;
				ecad_set_resistor(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize);
				ecad_active_id = ecad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (ecad_select == SELECT_XY1) {
		sprintf(gui_info, "Resistor-Start-Possition: x=?, y=? (%s)", tmp_str);
	} else if (ecad_select == SELECT_XY2) {
		sprintf(gui_info, "Resistor-End-Possition: x=%i, y=%i --> x=?, y=? (%s)", ecad_x1, ecad_y1, tmp_str);
	}
	return 0;
}


