
#define GROUP_MAIN			0
#define GROUP_TOOLBAR			1
#define GROUP_GRID			2
#define GROUP_DIRLIST			3

#define ICON_NEW			11
#define ICON_LOAD			12
#define ICON_SAVE			13
#define ICON_SAVE_IMG			14
#define ICON_SAVE_HM			15
#define ICON_UNDO			16
#define ICON_EXIT			17
#define ICON_SAVE_IMAGE			18
#define ICON_EXPORT_PDF			19
#define ICON_PRINT_IMAGE		20
#define OBJECT_LIST			21
#define EXPORT_IMAGE			22
#define ICON_SAVE_HM1			23
#define ICON_SAVE_HM2			24

SDL_Surface *tmp_image = NULL;
char directory_path[512];
char dirlist_str[4096];

#define DRAW_SELECT    30
#define DRAW_LINE      31
#define DRAW_LINES     32
#define DRAW_PAD       33
#define DRAW_IC        34
#define DRAW_TO220     35
#define DRAW_RECTANGLE 36
#define DRAW_TEXT      37
#define DRAW_BOX       39
#define DRAW_MOUNT     40
#define DRAW_RESISTOR  41
#define DRAW_MOVE      42
#define DRAW_XTAL      43
#define DRAW_GND       44
#define DRAW_PINCONN   45

#define GRID_SNAP            50
#define GRID_VIEW            51
#define TOGGLE_SHOW_TOP_LABEL 53
#define TOGGLE_SHOW_BOTTOM_CU 54
#define TOGGLE_SHOW_DRILL     55
#define TOGGLE_SHOW_3D        56

#include "ecad.c"
#include "cnc-struct.c"
#include "cnc.c"
#include "cnc-interface.h"
#include "cnc-interface.c"
#include "cnc_2d_liner.c"
#include "cnc_2d_outliner.c"
#include "cnc_2d_fill.c"
#include "cnc_2d_fill_objects.c"

int frontend_mdown_object_list(void) {
	static int mode = 0;
	int selected = (event.button.y - Widget[WidgetID[100]].y) / 20;
	char tmp_str[4096];
	char tmp2_str[4096];
	char *loc1;
	char *loc2;
	int n = 0;
	loc2 = dirlist_str;
	while ((loc1 = strstr(loc2, ";")) != 0) {
		strcpy(tmp_str, loc2);
		tmp_str[strstr(tmp_str, ";") - tmp_str] = 0;
		loc2 = loc1 + 1;
		if (n++ == selected) {
			if (strcmp(tmp2_str, "..") == 0) {
				dirname(directory_path);
				frontend_mdown_load();
			} else {
				sprintf(tmp2_str, "%s/%s", directory_path, tmp_str);
				if (frontend_is_directory(tmp2_str) == 1) {
					strcpy(directory_path, tmp2_str);
					frontend_mdown_load();
				} else {
					sprintf(tmp_str, "Electronic-CAD (%s)", tmp2_str);
					SDL_WM_SetCaption(tmp_str, tmp_str);
					ecad_file_load(tmp2_str);
					gui_hide_group(GROUP_DIRLIST);
				}
			}
			break;
		}
	}
	return 0;
}

int frontend_mdown_save_image(void) {

	// ecad_file_add_lib("/tmp/tt2.ecad");
	// ecad_file_add_hpgl("/tmp/test.plt");
	ecad_file_add_dxf("/tmp/dxf-out.dxf");
// 	ecad_file_add_dxf("/tmp/daemon.dxf");

	return 0;

	char filename[256];
	ecad_select_delete();
	ecad_clean_select();
	strcpy(filename, "/tmp/image.bmp");
	sprintf(gui_info, "Saving Bitmap: %s ...", filename);
	frontend_draw_info(gui_info);

	ecad_mouse_mode = M_NONE;
	ecad_clean_select();
	if (ecad_raster_view == 1) {
		ecad_raster_view = 0;
		ecad_draw();
		ecad_raster_view = 1;
	} else {
		ecad_draw();
	}
	ecad_select_delete();

	SDL_SaveBMP(ECAD_Surface, filename);
	sprintf(gui_info, "Saving Bitmap: %s ...done", filename);
	return 0;
}

int frontend_mdown_cnc_top_label(void) {
	char filename[256];
	int review_raster = 0;
	ecad_select_delete();
	ecad_clean_select();
	ecad_mouse_mode = M_NONE;
	ecad_clean_select();
	ecad_zoom = 1.0;
	ecad_export = 1;
	if (ecad_raster_view == 1) {
		review_raster = 1;
		ecad_raster_view = 0;
	}

	ECAD_Surface = SDL_CreateRGBSurface(SDL_SWSURFACE, ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100, 32, rmask, gmask, bmask, amask);

	ecad_show_bottom_cu = 0;
	ecad_show_top_label = 1;
	ecad_show_drill = 0;
	ecad_draw();

	cnc_start(ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100);
	cnc_reset();
// 	cnc_2d_liner(ECAD_Surface, 255, 0, 0, ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100, 1);
	cnc_stop();

	SDL_FreeSurface(ECAD_Surface);
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;

	if (review_raster == 1) {
		ecad_raster_view = 1;
	}
	ecad_show_bottom_cu = 1;
	ecad_show_top_label = 1;
	ecad_show_drill = 1;
	ecad_export = 0;
	ecad_select_delete();
	return 0;
}

int frontend_mdown_cnc_drill(void) {
	char filename[256];
	int review_raster = 0;
	ecad_select_delete();
	ecad_clean_select();
	ecad_mouse_mode = M_NONE;
	ecad_clean_select();
	ecad_zoom = 1.0;
	ecad_export = 1;
	if (ecad_raster_view == 1) {
		review_raster = 1;
		ecad_raster_view = 0;
	}

	ECAD_Surface = SDL_CreateRGBSurface(SDL_SWSURFACE, ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100, 32, rmask, gmask, bmask, amask);

	ecad_show_bottom_cu = 0;
	ecad_show_top_label = 0;
	ecad_show_drill = 1;
	ecad_draw();
	cnc_start(ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100);
	cnc_reset();
// 	cnc_2d_outliner(ECAD_Surface, z_stop, 0, 0, ECAD_Surface->w, ECAD_Surface->h);
	cnc_stop();

	SDL_FreeSurface(ECAD_Surface);
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;

	if (review_raster == 1) {
		ecad_raster_view = 1;
	}
	ecad_show_bottom_cu = 1;
	ecad_show_top_label = 1;
	ecad_show_drill = 1;
	ecad_export = 0;
	ecad_select_delete();
	return 0;
}

int frontend_show_stat(char *text, int percent) {
	gui_percent = percent;
	sprintf(gui_info, "%s: %i%%", text, gui_percent);
	gui_update_button(WidgetID[GUI_INFO], gui_info);
	gui_update_progress(WidgetID[GUI_PROGRESS], gui_percent);
	SDL_GL_SwapBuffers();
	return 0;
}


int frontend_mdown_cnc_bottom_cu(void) {
	int review_raster = 0;
	int ecad_id = 0;
	ecad_select_delete();
	ecad_clean_select();
	ecad_mouse_mode = M_NONE;
	ecad_clean_select();
	ecad_zoom = 1.0;
	ecad_export = 1;
	if (ecad_raster_view == 1) {
		review_raster = 1;
		ecad_raster_view = 0;
	}
	ECAD_Surface = SDL_CreateRGBSurface(SDL_SWSURFACE, ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100, 32, rmask, gmask, bmask, amask);
	if (ECAD_Surface != NULL) {
		// CNC-Start
		frontend_show_stat("Setup CNC", 0);
		cnc_start(ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100);
		cnc_reset();
		frontend_show_stat("Start-Possition anfahren", 0);
		cnc_soft_start(1);
		cnc_go_z(0);	
		cnc_go_xy(ecad_minsize_x(), ECAD_Surface->h - ecad_minsize_y());

		// Rahmen frsen
		frontend_show_stat("Rahmen frsen", 0);
		cnc_drill_set_speed(255);
		cnc_go_z(z_stop);
		cnc_go_xy(ecad_size_x(), ECAD_Surface->h - ecad_minsize_y());
		frontend_show_stat("Rahmen frsen", 25);
		cnc_go_xy(ecad_size_x(), ECAD_Surface->h - ecad_size_y());
		frontend_show_stat("Rahmen frsen", 50);
		cnc_go_xy(ecad_minsize_x(), ECAD_Surface->h - ecad_size_y());
		frontend_show_stat("Rahmen frsen", 75);
		cnc_go_xy(ecad_minsize_x(), ECAD_Surface->h - ecad_minsize_y());
		frontend_show_stat("Rahmen frsen", 100);
		cnc_go_z(0);
		cnc_drill_set_speed(0);

		// CU-Layer frsen
		frontend_show_stat("Layout frsen", 0);
		ecad_show_bottom_cu = 1;
		ecad_show_top_label = 0;
		ecad_show_drill = 0;
		ecad_draw();
		fprintf(stderr, "%i - %i\n", ecad_zoom_int(ecad_size_x()) + 100, ecad_zoom_int(ecad_size_y()) + 100);
		// remove GND-Lines
		for (ecad_id = 0; ecad_id < ECAD_MAX; ecad_id++) {
			if (ECAD[ecad_id].type == DRAW_GND) {
				fprintf(stderr, "GND: %i = %i\n", ECAD[ecad_id].x1, ecad_zoom_int(ECAD[ecad_id].x1));
				sge_FloodFill(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1), ecad_zoom_int(ECAD[ecad_id].y1), SDL_MapRGB(ECAD_Surface->format, 0, 0, 255));
			}
		}
		cnc_soft_start(1);
		cnc_2d_outline_objects(ECAD_Surface, 1, 1, z_stop, 1, 0, "Layout frsen");

		// Bohrungen frsen
		frontend_show_stat("Bohrungen frsen", 0);
		ecad_show_bottom_cu = 0;
		ecad_show_top_label = 0;
		ecad_show_drill = 1;
		ecad_draw();
		cnc_soft_start(0);
		cnc_2d_outline_objects(ECAD_Surface, 1, 1, z_stop, 1, 1, "Bohrungen frsen");

		// CNC-Stop
		cnc_stop();
		SDL_FreeSurface(ECAD_Surface);
	} else {
		fprintf(stderr, "Cant allocate Memory to Outline the Layout !!!\n");
		gui_percent = 0;
		sprintf(gui_info, "Outliner: Cant allocate Memory !!!!");
	}
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;

	if (review_raster == 1) {
		ecad_raster_view = 1;
	}
	ecad_show_bottom_cu = 1;
	ecad_show_top_label = 1;
	ecad_show_drill = 1;
	ecad_export = 0;
	ecad_select_delete();
exit (0);
	return 0;
}

int frontend_mdown_save(void) {
	char filename[256];
	strcpy(filename, "/tmp/tt.ecad");
	ecad_file_save(filename);
	return 0;
}

int frontend_mdown_new(void) {
	SDL_WM_SetCaption("Electronic-CAD", "Electronic-CAD");
	ecad_init();
	return 0;
}

int frontend_mdown_load(void) {
	DIR *dir;
	struct dirent *dir_entry;
	char tmp_str[512];
	strcpy(dirlist_str, "");
	strcat(dirlist_str, "..;");
	if ((dir = opendir(directory_path)) != NULL) {
		while ((dir_entry = readdir(dir)) != 0) {
			if (dir_entry->d_name[0] != '.') {
				sprintf(tmp_str, "%s/%s", directory_path, dir_entry->d_name);
				if (frontend_is_directory(tmp_str) == 1) {
					strcat(dirlist_str, dir_entry->d_name);
					strcat(dirlist_str, ";");
				} else if (strstr(tmp_str, ".ecad\0") != 0) {
					strcat(dirlist_str, dir_entry->d_name);
					strcat(dirlist_str, ";");
				}
			}
		}
		closedir(dir);
	}
	gui_update_list(WidgetID[100], dirlist_str, 50, 50, 500, 450, GROUP_DIRLIST, "Verzeichnis");
	gui_show_group(GROUP_DIRLIST);
	return 0;
}

int frontend_mdown_exit(void) {
	gui_running = 0;
	return 0;
}

int frontend_is_directory(char *path) {
        struct stat buf;
        if (stat(path,&buf) != 0) {
                return 0;
        }
        if (S_ISDIR(buf.st_mode) == 1) {
                return 1;
        } else {
                return 0;
        }
}

int frontend_draw_info(char *info_str) {
	gui_update_button(WidgetID[GUI_INFO], info_str);
	gui_draw();
}

int frontend_add_info(void) {
	WidgetID[2] = gui_add_canvas(5, SCREEN_Y - 40, SCREEN_X - 10, 35, GROUP_MAIN, "Info-Frame");
	boxRGBA(Widget[WidgetID[2]].surface, 0, 0, SCREEN_X - 10, 35, 255, 255, 255, 255);
	WidgetID[GUI_INFO] = gui_add_button(" ", 10, SCREEN_Y - 32, SCREEN_X - 220, 20, GROUP_MAIN, "Info-Text");
	WidgetID[GUI_PROGRESS] = gui_add_progress(50, SCREEN_X - 205, SCREEN_Y - 32, 195, 20, GROUP_MAIN, "Progress-Bar");
	return 0;
}

int frontend_add_menu(void) {
	char tmp_str[256];
	int bt_n = 0;
	int bt_diff_x = 27;

	WidgetID[99] = gui_add_canvas(5, 5, SCREEN_X - 10, 30, GROUP_MAIN, "Menu");
	bt_n = 0;
	WidgetID[ICON_NEW]       = gui_add_icon("filenew", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "neue Datei erstellen");
	Widget[WidgetID[ICON_NEW]].mdown = frontend_mdown_new;
	strcpy(Widget[WidgetID[ICON_NEW]].hotkey, "n");
	WidgetID[ICON_LOAD]       = gui_add_icon("fileopen", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Project(.ecad) ffnen");
	Widget[WidgetID[ICON_LOAD]].mdown = frontend_mdown_load;
	strcpy(Widget[WidgetID[ICON_LOAD]].hotkey, "o");
	WidgetID[ICON_SAVE]       = gui_add_icon("filesave", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Project(.ecad) speichern");
	Widget[WidgetID[ICON_SAVE]].mdown = frontend_mdown_save;
	strcpy(Widget[WidgetID[ICON_SAVE]].hotkey, "s");
	bt_n++;
	WidgetID[ICON_SAVE_IMG]       = gui_add_icon("image", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Bitmap(.bmp) speichern");
	Widget[WidgetID[ICON_SAVE_IMG]].mdown = frontend_mdown_save_image;
	strcpy(Widget[WidgetID[ICON_SAVE_IMG]].hotkey, "i");

	bt_n++;
	WidgetID[GRID_SNAP] = gui_add_icon("grid_snap", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "am Raster ausrichten");
	strcpy(Widget[WidgetID[GRID_SNAP]].hotkey, "r");
	Widget[WidgetID[GRID_SNAP]].mdown = ecad_image_raster_snap;
	Widget[WidgetID[GRID_SNAP]].type = 1;
	Widget[WidgetID[GRID_SNAP]].action = 2;
	WidgetID[GRID_VIEW] = gui_add_icon("grid", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Raster anzeigen");
	strcpy(Widget[WidgetID[GRID_VIEW]].hotkey, "g");
	Widget[WidgetID[GRID_VIEW]].mdown = ecad_image_raster_view;
	Widget[WidgetID[GRID_VIEW]].type = 1;
	Widget[WidgetID[GRID_VIEW]].action = 2;
	bt_n++;
	WidgetID[TOGGLE_SHOW_BOTTOM_CU] = gui_add_icon("view_bottom_cu", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Bottom-CU anzeigen");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].hotkey, "b");
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].mdown = ecad_toggle_show_bottom_cu;
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].type = 1;
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].action = 2;
	WidgetID[TOGGLE_SHOW_TOP_LABEL] = gui_add_icon("view_top_label", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Top-Label anzeigen");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].hotkey, "l");
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].mdown = ecad_toggle_show_top_label;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].type = 1;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].action = 2;
	WidgetID[TOGGLE_SHOW_DRILL] = gui_add_icon("view_drill", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Drill anzeigen");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_DRILL]].hotkey, "d");
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].mdown = ecad_toggle_show_drill;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].type = 1;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].action = 2;

	bt_n++;
	WidgetID[TOGGLE_SHOW_3D] = gui_add_icon("3d_view", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "3D-Ansicht");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_3D]].hotkey, "m");
	Widget[WidgetID[TOGGLE_SHOW_3D]].mdown = ecad_view_3d;

	bt_n++;
	WidgetID[ICON_SAVE_HM]       = gui_add_icon("point", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "untere Kupferbahnen frsen");
	Widget[WidgetID[ICON_SAVE_HM]].mdown = frontend_mdown_cnc_bottom_cu;
	strcpy(Widget[WidgetID[ICON_SAVE_HM]].hotkey, "h");
	WidgetID[ICON_SAVE_HM1]       = gui_add_icon("text", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "obere Beschriftung plotten");
	Widget[WidgetID[ICON_SAVE_HM1]].mdown = frontend_mdown_cnc_top_label;
	strcpy(Widget[WidgetID[ICON_SAVE_HM1]].hotkey, "h");
	WidgetID[ICON_SAVE_HM2]       = gui_add_icon("drill", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Bohrungen frsen");
	Widget[WidgetID[ICON_SAVE_HM2]].mdown = frontend_mdown_cnc_drill;
	strcpy(Widget[WidgetID[ICON_SAVE_HM2]].hotkey, "h");

	WidgetID[ICON_EXIT]       = gui_add_icon("exit", SCREEN_X - 10 - bt_diff_x, 10, GROUP_MAIN, "Beenden");
	Widget[WidgetID[ICON_EXIT]].mdown = frontend_mdown_exit;
	strcpy(Widget[WidgetID[ICON_EXIT]].hotkey, "q");

	return 0;
}

int frontend_add_object_list(void) {
	strcpy(dirlist_str, "");
	WidgetID[100] = gui_add_list(dirlist_str, 50, 50, 500, 450, GROUP_DIRLIST, "Verzeichnis");
	Widget[WidgetID[100]].mdown = frontend_mdown_object_list;
	Widget[WidgetID[100]].type = 2;
	Widget[WidgetID[100]].action = 2;
	gui_hide_group(GROUP_DIRLIST);
	return 0;
}

int frontend_add_ecad_menu(void) {
	char tmp_str[256];
	int bt_n = 0;
	int bt_diff_y = 27;
	WidgetID[99] = gui_add_canvas(5, 40, 30, SCREEN_Y - 85, GROUP_TOOLBAR, "Werkzeugleiste");

	WidgetID[DRAW_SELECT] = gui_add_icon("edit", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Entfernen/Neuzeichnen");
	strcpy(Widget[WidgetID[DRAW_SELECT]].hotkey, "e");
	Widget[WidgetID[DRAW_SELECT]].mdown = ecad_select_delete;
	Widget[WidgetID[DRAW_SELECT]].type = 2;

	WidgetID[DRAW_MOVE] = gui_add_icon("edit", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Verschieben");
	strcpy(Widget[WidgetID[DRAW_MOVE]].hotkey, "1");
	Widget[WidgetID[DRAW_MOVE]].mdown = ecad_select_move;
	Widget[WidgetID[DRAW_MOVE]].type = 2;

	bt_n++;
	WidgetID[DRAW_LINE] = gui_add_icon("line", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Linie zeichnen");
	strcpy(Widget[WidgetID[DRAW_LINE]].hotkey, "2");
	Widget[WidgetID[DRAW_LINE]].mdown = ecad_select_line;
	ecad_drawit[DRAW_LINE] = ecad_draw_line;
	ecad_mover[DRAW_LINE] = ecad_mover_line;
	ecad_mdown[DRAW_LINE] = ecad_mdown_line;
	ecad_mup[DRAW_LINE] = ecad_mup_line;
	ecad_input[DRAW_LINE] = ecad_input_line;
	Widget[WidgetID[DRAW_LINE]].type = 2;

	WidgetID[DRAW_LINES] = gui_add_icon("lines", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Linien zeichnen");
	strcpy(Widget[WidgetID[DRAW_LINES]].hotkey, "3");
	Widget[WidgetID[DRAW_LINES]].mdown = ecad_select_lines;
	ecad_drawit[DRAW_LINES] = ecad_draw_lines;
	ecad_mover[DRAW_LINES] = ecad_mover_lines;
	ecad_mdown[DRAW_LINES] = ecad_mdown_lines;
	ecad_mup[DRAW_LINES] = ecad_mup_lines;
	ecad_input[DRAW_LINES] = ecad_input_lines;
	Widget[WidgetID[DRAW_LINES]].type = 2;

	WidgetID[DRAW_PAD] = gui_add_icon("point", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Ltpunkt zeichnen");
	strcpy(Widget[WidgetID[DRAW_PAD]].hotkey, "4");
	Widget[WidgetID[DRAW_PAD]].mdown = ecad_select_pad;
	ecad_drawit[DRAW_PAD] = ecad_draw_pad;
	ecad_mover[DRAW_PAD] = ecad_mover_pad;
	ecad_mdown[DRAW_PAD] = ecad_mdown_pad;
	ecad_mup[DRAW_PAD] = ecad_mup_pad;
	ecad_input[DRAW_PAD] = ecad_input_pad;
	Widget[WidgetID[DRAW_PAD]].type = 2;

	WidgetID[DRAW_PINCONN] = gui_add_icon("point", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Ltpunkt zeichnen");
	strcpy(Widget[WidgetID[DRAW_PINCONN]].hotkey, "4");
	Widget[WidgetID[DRAW_PINCONN]].mdown = ecad_select_pinconn;
	ecad_drawit[DRAW_PINCONN] = ecad_draw_pinconn;
	ecad_mover[DRAW_PINCONN] = ecad_mover_pinconn;
	ecad_mdown[DRAW_PINCONN] = ecad_mdown_pinconn;
	ecad_mup[DRAW_PINCONN] = ecad_mup_pinconn;
	ecad_input[DRAW_PINCONN] = ecad_input_pinconn;
	Widget[WidgetID[DRAW_PINCONN]].type = 2;

	WidgetID[DRAW_IC] = gui_add_icon("ic", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "IC-Sockel zeichnen");
	strcpy(Widget[WidgetID[DRAW_IC]].hotkey, "5");
	Widget[WidgetID[DRAW_IC]].mdown = ecad_select_ic;
	ecad_drawit[DRAW_IC] = ecad_draw_ic;
	ecad_mover[DRAW_IC] = ecad_mover_ic;
	ecad_mdown[DRAW_IC] = ecad_mdown_ic;
	ecad_mup[DRAW_IC] = ecad_mup_ic;
	ecad_input[DRAW_IC] = ecad_input_ic;
	Widget[WidgetID[DRAW_IC]].type = 2;

	WidgetID[DRAW_TO220] = gui_add_icon("nmos", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "TO220 zeichnen");
	strcpy(Widget[WidgetID[DRAW_TO220]].hotkey, "6");
	Widget[WidgetID[DRAW_TO220]].mdown = ecad_select_to220;
	ecad_drawit[DRAW_TO220] = ecad_draw_to220;
	ecad_mover[DRAW_TO220] = ecad_mover_to220;
	ecad_mdown[DRAW_TO220] = ecad_mdown_to220;
	ecad_mup[DRAW_TO220] = ecad_mup_to220;
	ecad_input[DRAW_TO220] = ecad_input_to220;
	Widget[WidgetID[DRAW_TO220]].type = 2;

	WidgetID[DRAW_RESISTOR] = gui_add_icon("resistor", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Wiederstand zeichnen");
	strcpy(Widget[WidgetID[DRAW_RESISTOR]].hotkey, "7");
	Widget[WidgetID[DRAW_RESISTOR]].mdown = ecad_select_resistor;
	ecad_drawit[DRAW_RESISTOR] = ecad_draw_resistor;
	ecad_mover[DRAW_RESISTOR] = ecad_mover_resistor;
	ecad_mdown[DRAW_RESISTOR] = ecad_mdown_resistor;
	ecad_mup[DRAW_RESISTOR] = ecad_mup_resistor;
	ecad_input[DRAW_RESISTOR] = ecad_input_resistor;
	Widget[WidgetID[DRAW_RESISTOR]].type = 2;

	WidgetID[DRAW_XTAL] = gui_add_icon("resistor", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Quarz zeichnen");
	strcpy(Widget[WidgetID[DRAW_XTAL]].hotkey, "8");
	Widget[WidgetID[DRAW_XTAL]].mdown = ecad_select_xtal;
	ecad_drawit[DRAW_XTAL] = ecad_draw_xtal;
	ecad_mover[DRAW_XTAL] = ecad_mover_xtal;
	ecad_mdown[DRAW_XTAL] = ecad_mdown_xtal;
	ecad_mup[DRAW_XTAL] = ecad_mup_xtal;
	ecad_input[DRAW_XTAL] = ecad_input_xtal;
	Widget[WidgetID[DRAW_XTAL]].type = 2;

	bt_n++;
	WidgetID[DRAW_MOUNT] = gui_add_icon("drill", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Bohrung zeichnen");
	strcpy(Widget[WidgetID[DRAW_MOUNT]].hotkey, "9");
	Widget[WidgetID[DRAW_MOUNT]].mdown = ecad_select_mount;
	ecad_drawit[DRAW_MOUNT] = ecad_draw_mount;
	ecad_mover[DRAW_MOUNT] = ecad_mover_mount;
	ecad_mdown[DRAW_MOUNT] = ecad_mdown_mount;
	ecad_mup[DRAW_MOUNT] = ecad_mup_mount;
	ecad_input[DRAW_MOUNT] = ecad_input_mount;
	Widget[WidgetID[DRAW_MOUNT]].type = 2;

	WidgetID[DRAW_RECTANGLE] = gui_add_icon("rectangle", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckigen Rahmen zeichnen");
	strcpy(Widget[WidgetID[DRAW_RECTANGLE]].hotkey, "0");
	Widget[WidgetID[DRAW_RECTANGLE]].mdown = ecad_select_rectangle;
	ecad_drawit[DRAW_RECTANGLE] = ecad_draw_rectangle;
	ecad_mover[DRAW_RECTANGLE] = ecad_mover_rectangle;
	ecad_mdown[DRAW_RECTANGLE] = ecad_mdown_rectangle;
	ecad_mup[DRAW_RECTANGLE] = ecad_mup_rectangle;
	ecad_input[DRAW_RECTANGLE] = ecad_input_rectangle;
	Widget[WidgetID[DRAW_RECTANGLE]].type = 2;

	WidgetID[DRAW_BOX] = gui_add_icon("rectangle-filled", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckige Flche zeichnen");
	strcpy(Widget[WidgetID[DRAW_BOX]].hotkey, "0");
	Widget[WidgetID[DRAW_BOX]].mdown = ecad_select_box;
	ecad_drawit[DRAW_BOX] = ecad_draw_box;
	ecad_mover[DRAW_BOX] = ecad_mover_box;
	ecad_mdown[DRAW_BOX] = ecad_mdown_box;
	ecad_mup[DRAW_BOX] = ecad_mup_box;
	ecad_input[DRAW_BOX] = ecad_input_box;
	Widget[WidgetID[DRAW_BOX]].type = 2;

	WidgetID[DRAW_TEXT] = gui_add_icon("text", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Text schreiben");
	strcpy(Widget[WidgetID[DRAW_TEXT]].hotkey, "t");
	Widget[WidgetID[DRAW_TEXT]].mdown = ecad_select_text;
	ecad_drawit[DRAW_TEXT] = ecad_draw_text;
	ecad_mover[DRAW_TEXT] = ecad_mover_text;
	ecad_mdown[DRAW_TEXT] = ecad_mdown_text;
	ecad_mup[DRAW_TEXT] = ecad_mup_text;
	ecad_input[DRAW_TEXT] = ecad_input_text;
	Widget[WidgetID[DRAW_TEXT]].type = 2;

	WidgetID[DRAW_GND] = gui_add_icon("point", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Masse/GND makieren (zur Optimierung der Masseflche)");
	Widget[WidgetID[DRAW_GND]].mdown = ecad_select_gnd;
	ecad_drawit[DRAW_GND] = ecad_draw_gnd;
	ecad_mover[DRAW_GND] = ecad_mover_gnd;
	ecad_mdown[DRAW_GND] = ecad_mdown_gnd;
	ecad_mup[DRAW_GND] = ecad_mup_gnd;
	ecad_input[DRAW_GND] = ecad_input_gnd;
	Widget[WidgetID[DRAW_GND]].type = 2;


	WidgetID[EXPORT_IMAGE] = gui_add_canvas(40, 40, SCREEN_X - 45, SCREEN_Y - 85, GROUP_MAIN, "Zeichenflche");
	Widget[WidgetID[EXPORT_IMAGE]].mover = ecad_image_mover;
	Widget[WidgetID[EXPORT_IMAGE]].mdown = ecad_image_mdown;
	Widget[WidgetID[EXPORT_IMAGE]].mup = ecad_image_mup;

	gui_input = ecad_image_input;

	ecad_init();
	
	Widget[WidgetID[EXPORT_IMAGE]].zoom = 1.0;

	return 0;
}

int frontend_init(void) {
	SDL_WM_SetCaption("Electronic-CAD", "Electronic-CAD");
	frontend_add_menu();
	frontend_add_info();
	frontend_add_ecad_menu();
	frontend_add_object_list();
	strcpy(directory_path, "/usr/share/doc/ecad/examples");
	cnc_init();

// 	glRotatef(-25.0, 1.0, 1.0, 0.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(Widget[WidgetID[EXPORT_IMAGE]].x, Widget[WidgetID[EXPORT_IMAGE]].y, Widget[WidgetID[EXPORT_IMAGE]].w, Widget[WidgetID[EXPORT_IMAGE]].h);
	glOrtho(0, Widget[WidgetID[EXPORT_IMAGE]].w, Widget[WidgetID[EXPORT_IMAGE]].h, 0, -Widget[WidgetID[EXPORT_IMAGE]].w, Widget[WidgetID[EXPORT_IMAGE]].w);

	return 0;
}
