
#define BAUDRATE	B9600
// #define BAUDRATE	B19200
// #define BAUDRATE	B38400
// #define BAUDRATE	B57600
// #define BAUDRATE	B115200
#define MODEMDEVICE "/dev/ttyS1"

int fd,c, res;
struct termios oldtio,newtio;
char serial_buf[255];
#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
fd_set readfs;
int    maxfd;
int    fd2;
struct timeval Timeout;
int serial_debug = 1;

int wait_for_rep(void) {
	int n = 0;
	while((res = read(fd, serial_buf + n, 1)) > 0 && serial_buf[n] != '\n') {
		n++;
	}
	serial_buf[n] = 0;
// 	fprintf(stderr, "REP=%s\n", serial_buf);

	if (strncmp(serial_buf, "OK", 2) == 0) {
		return 0;
	} else if (strncmp(serial_buf, "ERR", 5) == 0) {
		fprintf(stderr, "Command Error\n");
		return 1;
	} else {
		fprintf(stderr, "Unknown replay: %s\n", serial_buf);
		return 2;
	}
	fprintf(stderr, "Connect Error\n");
	return 3;
}

int serial_receive(char *repl) {
	int n = 0;
	while((res = read(fd, serial_buf + n, 1)) > 0 && serial_buf[n] != '\n') {
		n++;
	}
	serial_buf[n] = 0;
	strcpy(repl, serial_buf);
	return 0;
}

int serial_send_receive(char *new_cmd, char *repl) {
	char cmd[256];
	char cmd_rep[256];
	unsigned int cmd_len = 0;
	unsigned int cmd_sum = 0;
	char *loc;
	int n = 0;
	strcpy(cmd, new_cmd);
	if (demo != 0) {
		fprintf(stderr, "CNC_TEST: %s\n", cmd);
	} else {
		cmd[strlen(cmd) - 1] = 0;
		cmd_len = strlen(cmd);
		cmd_sum = 0;
		for (n = 0; n < cmd_len; n++) {
			cmd_sum += cmd[n];
		}
		cmd_sum = cmd_sum / cmd_len + cmd_len;
		cmd[cmd_len] = cmd_sum;
		cmd[cmd_len + 1] = '\n';
		cmd[cmd_len + 2] = 0;
		if (serial_debug == 1) {
			fprintf(stderr, "CNC_SEND_SUM: %s -- %i -- %c\n", cmd, cmd_sum, cmd_sum);
		}
		write(fd, cmd, strlen(cmd));
		serial_receive(repl);
	}
	return 0;
}

int serial_send(char *new_cmd) {
	char *loc;
	char cmd[256];
	unsigned int n = 0;
	unsigned int cmd_len = 0;
	unsigned int cmd_sum = 0;
	strcpy(cmd, new_cmd);
	if (demo != 0) {
		fprintf(stderr, "CNC_TEST: %s\n", cmd);
	} else {
// 		fprintf(stderr, "CNC_SEND: %s\n", cmd);
		cmd[strlen(cmd) - 1] = 0;
		cmd_len = strlen(cmd);
		cmd_sum = 0;
		for (n = 0; n < cmd_len; n++) {
			cmd_sum += cmd[n];
		}
		cmd_sum = cmd_sum / cmd_len + cmd_len;
		cmd[cmd_len] = cmd_sum;
		cmd[cmd_len + 1] = '\n';
		cmd[cmd_len + 2] = 0;
		
		if (serial_debug == 1) {
			fprintf(stderr, "CNC_SEND_SUM: %s -- %i -- %c\n", cmd, cmd_sum, cmd_sum);
		}
		write(fd, cmd, strlen(cmd));
		n = 0;
		while (wait_for_rep() != 0) {
			if (n == 5) {
				fprintf(stderr, "Error while sending to CNC\n");
				fprintf(stderr, "Exit !!!\n");
				return 1;
			}
			fprintf(stderr, "	Retry(%i): CNC_SEND: %s\n", n, cmd);
			write(fd, cmd, strlen(cmd));
			n++;
		}
	}
	return 0;
}

int serial_close(void) {
	if (fd >= 0) {
		close(fd);
	}
	return 0;
}

int serial_open(void) {
	if ((fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY )) >= 0) {
		tcgetattr(fd,&oldtio); /* save current port settings */
		bzero(&newtio, sizeof(newtio));
		newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
		newtio.c_iflag = IGNPAR;
		newtio.c_oflag = 0;
		newtio.c_lflag = ICANON;

		newtio.c_cc[VINTR]    = 0;     /* Ctrl-c */
		newtio.c_cc[VQUIT]    = 0;     /* Ctrl-\ */
		newtio.c_cc[VERASE]   = 0;     /* del */
		newtio.c_cc[VKILL]    = 0;     /* @ */
		newtio.c_cc[VEOF]     = 4;     /* Ctrl-d */
		newtio.c_cc[VTIME]    = 0;     /* inter-character timer unused */
		newtio.c_cc[VMIN]     = 10;     /* blocking read until 1 character arrives */
		newtio.c_cc[VSWTC]    = 0;     /* '\0' */
		newtio.c_cc[VSTART]   = 0;     /* Ctrl-q */
		newtio.c_cc[VSTOP]    = 0;     /* Ctrl-s */
		newtio.c_cc[VSUSP]    = 0;     /* Ctrl-z */
		newtio.c_cc[VEOL]     = 0;     /* '\0' */
		newtio.c_cc[VREPRINT] = 0;     /* Ctrl-r */
		newtio.c_cc[VDISCARD] = 0;     /* Ctrl-u */
		newtio.c_cc[VWERASE]  = 0;     /* Ctrl-w */
		newtio.c_cc[VLNEXT]   = 0;     /* Ctrl-v */
		newtio.c_cc[VEOL2]    = 0;     /* '\0' */

		tcflush(fd, TCIFLUSH);
		tcsetattr(fd,TCSANOW,&newtio);

		maxfd = MAX (fd, fd2) + 1;
		Timeout.tv_usec = 0;
		Timeout.tv_sec  = 1;

		return 0;
	}
	return 1;
}

